;(function () {
	
var root = this,
    methods = {},
    stub = { root: null, content: null, overflow: null };

if (!_.isUndefined(root.eAu.Tooltip)) { return; }

$(function () {
	// Добавляем необходимую разметку в DOM
	var ttContainer = document.getElementById('eAu-tooltips-container');
	if (ttContainer) {
		$(ttContainer).remove();
	}
	var tplStub = _.template([
		'<div id="<%= idPrefix %>tooltip-stub">',
		'	<div id="<%= idPrefix %>tooltip-stub-overflow"><div class="<%= idPrefix %>tooltip-content <%= idPrefix %>tooltip-common" id="<%= idPrefix %>tooltip-stub-content"></div></div>',
		'</div>'
	].join('\n'));
	$(document.body)
		.append('<div id="eAu-tooltips-container" class="content">'+ tplStub({idPrefix: 'eAu-'}) +'</div>');

	stub.root = document.getElementById('eAu-tooltip-stub');
	stub.content = document.getElementById('eAu-tooltip-stub-content');
	stub.overflow = document.getElementById('eAu-tooltip-stub-overflow');
});

var tplTT = _.template([
	'<div id="<%= id %>" class="eAu-tooltip">',
	'	<div class="eAu-tooltip-box-wrapper">',
	'		<div class="eAu-tooltip-box">',
	'			<div class="eAu-tooltip-common eAu-tooltip-content">',
	'			</div>',
	'		</div>',
	'	</div>',
	'	<div class="eAu-tooltip-stem"></div>',
	'</div>'
].join('\n'));

function getBoxDimensions (content) {
	var ret;

	if (typeof content == 'string') {
		$(stub.content).html(content);
	} else {
		$(stub.content).html('').append(content);
	}

	if ($(stub.content).find('img').length == 0 || typeof content != 'string') {
		var contentD = {
			height: $(stub.content).height(),
			width: $(stub.content).width()
		};
		var overflowD = {
			height: $(stub.overflow).height(),
			width: $(stub.overflow).width()
		};
		if (contentD.height > overflowD.height) {
			ret = overflowD;
			ret.hasOverflow = true;
		} else {
			ret = contentD;
		}
	}

	if (typeof content == 'string') {
		$(stub.content).html('');
	} else {
		content.detach();
	}
	return ret;
}

function generateId (me) {
	if (_.isUndefined(me.constructor.uniqueId)) {
		me.constructor.uniqueId = 0;
	}
	return 'eAu-tooltip-' + (++me.constructor.uniqueId).toString();
}

function setInitialPosition (me, options) {
	var ttH = $(me._dom).outerHeight();
	var ttW = $(me._dom).outerWidth();
	var diff = 0;
	var targetPosition;
	var offset;
	var pos = 'above';
	var stemHeight = $(me._dom).find('.eAu-tooltip-stem').outerHeight(true);

	if (options.target) {
		targetPosition = $(options.target).offset();
		options.left = targetPosition.left;
		me._target = options.target;
		$(me._dom).position({
			my: 'bottom',
			at: 'top',
			offset: '-10 -5',
			collision: 'fit flip',
			of: options.target
		});
		offset = targetPosition.left - parseInt($(me._dom).css('left'), 10) + 5;
		if (offset < 5) { offset = 5; }
		$(me._dom).find('.eAu-tooltip-stem').css('left', offset);
		if ($(me._dom).offset().top > targetPosition.top)
			pos = 'below';
		$(me._dom)
			.removeClass('eAu-tooltip-below eAu-tooltip-above eAu-tooltip-atright eAu-tooltip-atleft')
			.addClass('eAu-tooltip-'+pos);
	}
/*
	if (options.left && options.top) {
		if (options.left + ttW > $(window).width()) {
			diff = Math.abs($(window).width() - options.left - ttW);
			options.left = $(window).width() - ttW;
		}
	} else if (options.target) {
		targetPosition = $(options.target).position();
	}

	var stemLeft = parseInt($(me._dom).find('.eAu-tooltip-stem').css('left'));
	stemLeft += diff;
	$(me._dom).find('.eAu-tooltip-stem').css('left', stemLeft);

	$(me._dom)
		.css({
			top: (options.top - ttH - 3),
			left: (options.left)
		});
	*/
}

function setDimensions (me, options) {
}

function setPosition (me, options) {
	var targetPosition;
	if (options.target) {
		targetPosition = $(options.target).position();
	} else {
		targetPosition = {
			left: options.left,
			top: options.top
		};
	}
}

function hasCache (me, content) {
	return !!me.constructor.cache && !!me.constructor.cache[content];
}

function hideTooltip (me) {
	$(me._dom).css({
		left: -30000
	});
}

function isTooltipVisible (me) {
	var position = $(me._dom).position();

	return position.left >= 0 && position.top >= 0;
}

$(document).bind('mouseup', function (event) {
	var $target = $(event.target),
	    $tooltip = $target.parents('.eAu-tooltip:first'),
	    $tooltips = $('.eAu-tooltip').not($tooltip);
	
	_.each($tooltips.get(), function (item) {
		var itemId = $(item).attr('id');
		if (eAu.Tooltip.instances[itemId]) {
			hideTooltip(eAu.Tooltip.instances[itemId]);
		}
	});
});
$(function () {
	$(window)
		.add('#content')
		.bind('scroll resize', function () {
			var $tooltips = $('.eAu-tooltip');

			_.each($tooltips.get(), function (item) {
				var itemId = $(item).attr('id');
				if (eAu.Tooltip.instances[itemId]) {
					hideTooltip(eAu.Tooltip.instances[itemId]);
				}
			});
		});
});

methods.initialize = function (content, options) {
	var instance
	  , me;
	if (!stub.root) {
		throw new Error('eAu.Tooltip@initialize: Tooltips can be created only after dom:loaded event');
		return;
	}
	content = content || '';
	options = _.extend({
		top: 0,
		left: 0
	}, options || {});
	this._content = content;
	if (!hasCache(this, content)) {
		this._id = generateId(this);
		this._boxDimensions = getBoxDimensions(content);

		$('#eAu-tooltips-container')
			.append(tplTT({id: this._id}));

		this._dom = document.getElementById(this._id);

		$(this._dom)
			.addClass('eAu-tooltip-above')
			.addClass(options.cls || '')
			.addClass(this._boxDimensions ? '' : 'eAu-tooltip-loading')
			.find('.eAu-tooltip-box')
			.css({
				width:  this._boxDimensions ? this._boxDimensions.width : '',
				height: this._boxDimensions ? this._boxDimensions.height : ''
			})
			.addClass(this._boxDimensions && this._boxDimensions.hasOverflow ? 'eAu-tooltip-box-has-overflow' : '')
			.find('.eAu-tooltip-content')
			.html('<div>' + this._content + '</div>');

		if (!this._boxDimensions) {
			me = this;
			me._imagesLeft = $(this._dom).find('.eAu-tooltip-box .eAu-tooltip-content img').bind('load error', function () {
				var c;
				me._imagesLeft--;
				if (me._imagesLeft == 0) {
					setTimeout(function () {
						var c = $(me._dom).find('.eAu-tooltip-box .eAu-tooltip-content > div:first')
						  , p = $(me._dom).find('.eAu-tooltip-box .eAu-tooltip-content');
						c.detach();
						me._boxDimensions = getBoxDimensions(c);
						if (me._boxDimensions) {
							$(me._dom).find('.eAu-tooltip-box')
								.css({
									width:  me._boxDimensions.width,
									height: me._boxDimensions.height
								})
								.addClass(me._boxDimensions.hasOverflow ? 'eAu-tooltip-box-has-overflow' : '');
						} else {
							$(me._dom).addClass('eAu-tooltip-load-error');
						}
						$(me._dom).removeClass('eAu-tooltip-loading')
						p.append(c);
						setInitialPosition(me, options);
					}, 1);
				}
			}).length;
			setTimeout(function () {
				
			}, 5000);
		}

		//setDimensions(this, options);
		setInitialPosition(this, options);

		if (_.isUndefined(this.constructor.instances)) {
			this.constructor.instances = {};
			this.constructor.cache = {};
		}
		this.constructor.instances[this._id] = this;
		this.constructor.cache[this._content] = this._id;
	} else {
		this._id = this.constructor.cache[this._content];
		instance = this.constructor.instances[this._id];
		this._boxDimensions = instance._boxDimensions;
		this._dom = instance._dom;
		this._imagesLeft = instance._imagesLeft;
		setInitialPosition(this, options);
	}
}

methods.destroy = function () {
	$(this._dom).remove();
}

root.eAu.Tooltip = eAu.Class.create(methods);
root.eAu.Tooltip.destroyAll = function() {
	var id;
	if (!root.eAu.Tooltip.instances) { return; }

	for (id in root.eAu.Tooltip.instances) {
		delete root.eAu.Tooltip.cache[root.eAu.Tooltip.instances[id]._content];
		root.eAu.Tooltip.instances[id].destroy();
		delete root.eAu.Tooltip.instances[id];
	}
}

return true;

})();


