/**
 * @author betalb
 */

if (!self.eU) { self.eU = {}; }

function pathMerge(base, relative) {
	base = base.replace(/\\/g, '/');
	relative = relative.replace(/\\/g, '/');
	if (relative.charAt(0) == '/') {
		relative = relative.substring(1, relative.length);
	}
	if (base.charAt(base.length - 1) == '/') {
		base = base.substring(0, base.length - 1);
	}
	return encodeURI(base + '/' + relative);
}

(function() {

if (!self.eAu) { self.eAu = {}; }
if (eAu.preloader) { return; }
//------------------------------------------------------------------------------
var handlers = {};
$.ajaxSetup({
	global: false
});
//------------------------------------------------------------------------------
function registerNewPreloader(extension, handler) {
	if (typeof handlers[extension] == "function") {
		return;
	}
	extension = extension.split(':')
	for (var i = 0, length = extension.length; i < length; ++i) {
		handlers[extension[i]] = handler;
	}
}
//------------------------------------------------------------------------------
function add(filename, callback, options) {
	options = _.extend({
		async: true
	}, options || {});
	var matches = filename.match(/\.([A-Za-z0-9\-_]+)$/);
	if (!matches || !matches[1]) { return; }
	if (!handlers[matches[1]]) {
		return 'Не зарегистрировано ни одного обработчика для расширения: "'+matches[1]+'"';
	}
	handlers[matches[1]].apply(null, [getLocalFilename(filename), callback, options]);
}
//---- helper functions --------------------------------------------------------
function parseXml (data) {
	if (data != null) {
		data = typeof data === 'string'
			? (new DOMParser()).parseFromString(data, "text/xml")
			: data;

		if (data && data.documentElement && !/parsererror|html/i.test(data.documentElement.nodeName)) {
			try {
				data.setProperty("SelectionLanguage", "XPath");
			} catch (error) {}
		} else {
			data = null;
		}
	}
	return data;
}
function parseXsl (data) {
	var xsl;

	try {
		xsl = new XSLTProcessor();
	} catch (error) {
		//console.log(error.message);
	}
	if (data != null && xsl) {
		try {
			data.setProperty("SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'");
			data.setProperty("AllowDocumentFunction", true);
			data.resolveExternals = true;
		} catch (error) {}
		try {
			xsl.importStylesheet(data);
			data = xsl;
		} catch (error) {
			data = null;
		}
	} else {
		data = null;
	}
	return data;
}
//------------------------------------------------------------------------------
registerNewPreloader('xml:php', function (filename, callback, options) {
	var deferred = $.Deferred();
	$.ajax(filename, {
		type:     'GET',
		dataType: 'text',
		async:    options.async
	}).done(function (data) {
		data = parseXml(data);
		if (data) {
			deferred.resolve(data);
		} else {
			deferred.reject();
		}
	}).fail(function () {
		deferred.reject();
	});

	deferred.always(function () {
		callback.apply(this, arguments);
	});

	return deferred.promise();
});
//------------------------------------------------------------------------------
registerNewPreloader('xsl', function (filename, callback, options) {
	var deferred = $.Deferred();
	$.ajax(filename, {
		type:     'GET',
		dataType: 'text',
		async:    options.async
	}).done(function (data) {
		data = parseXsl(parseXml(data));
		if (data) {
			deferred.resolve(data);
		} else {
			deferred.reject();
		}
	}).fail(function () {
		deferred.reject();
	});

	deferred.always(function () {
		callback.apply(this, arguments);
	});

	return deferred.promise();
});
//------------------------------------------------------------------------------
var deferreds = {};
registerNewPreloader('json', function (filename, callback, options) {
	// Всегда асинхронный
	if (!options.id) {
		throw new Error('pass id in options');
	}

	if (!deferreds[options.id] || deferreds[options.id].isRejected()) {
		deferreds[options.id] = $.Deferred();

		yepnope({
			load: 'js!' + filename,
			complete: function () {
				// Reject загрузки если по каким-либо причинам загруженный файл
				// не смог известить о своей загрузке
				_.delay(function () {
					deferreds[options.id].reject();
				}, 1000);
			}
		});
	}

	deferreds[options.id].always(function () {
		callback.apply(this, arguments);
	});

	return deferreds[options.id].promise();
});
//------------------------------------------------------------------------------
eAu.preloader = {
	add: function (filename, callback, options){
		if (!filename || filename == '' || !callback || typeof callback != 'function') { return false; }
		return add.apply(null, arguments);
	},
	register: function (extension, handler) {
		if (!extension || extension == '' || !handler) { return false; }
		return registerNewPreloader.apply(null, arguments);
	},
	loaded: function (id, value) {
		var deferred = deferreds[id]
		  , data;

		if (deferred) {
			data = parseXml(value);
			if (data && /\.xsl/i.test(id)) {
				data = parseXsl(data);
			}
			if (data) {
				deferred.resolve(data);
			} else {
				deferred.reject();
			}
		}
	}
};

})();

(function() {

if (!self.eAu) { self.eAu = {}; }
if (eAu.Xml) { return; }

if (!eAu.options || !eAu.options.Xml) {
	if (!eAu.options) { eAu.options = {}; }
	eAu.options.Xml = {};
}

// Private methods
eAu._Xml = {
	isNode: function(object) {
		return !!object && _.isNumber(object.nodeType);
	},
	isElement: function(object) {
		return isNode(object) && object.nodeType == 1;
	},
	isDocElement: function(el) {
		return isNode(el.parentNode) && (el.parentNode.nodeType == 9 || el.parentNode.nodeType == 11);
	},
	readAttribute: function(el, attributeName) {
		return el.getAttribute(attributeName);
	},
	writeAttribute: function(el, attributeName, attributeValue) {
		return el.setAttribute(attributeName, attributeValue);
	},
	removeAttribute: function(el, attributeName) {
		return el.removeAttribute(attributeName);
	},
	parentElement: function(el) {
		return isElement(el.parentNode) ? el.parentNode : null;
	},
	select: function(el, options) {
		options = getSelectOptions(options);
		var func = options.single ? 'selectSingleNode' : 'selectNodes';
		var nodes = el[func](options.selector);
		if (options.single) {
			if (isElement(nodes)) { return nodes; }
			else { return null; }
		} else {
			var elements = [];
			for (var i = 0, length = nodes.length; i < length; ++i) {
				if (isElement(nodes.item(i))) {
					elements.push(nodes.item(i));
				}
			}
			return elements;
		}
	},
	isVisible: function(element, checkParents) {
		var el = element;
		if (!checkParents) {
			return readAttribute(el, opt.visibilityAttr) != opt.hidden;
		} else {
			while (el && isVisible(el) && !isDocElement(el)) {
				el = el.parentNode;
			}
			if (!isElement(el)) { return true; }
			return isVisible(el);
		}
	}
};
//------------------------------------------------------------------------------
var opt = _.extend({
	visibilityAttr: 'visibility',
	groupAttr:      'group-text-nodes',
	srcAttr:        'src',
	idAttr:         'DB_ID',
	hidden:         'hidden',
	visible:        'visible'
}, eAu.options.Xml || {});
var opts = eAu.options;
//------------------------------------------------------------------------------
var isNode          = eAu._Xml.isNode;
var select          = eAu._Xml.select;
var isVisible       = eAu._Xml.isVisible;
var isElement       = eAu._Xml.isElement;
var isDocElement    = eAu._Xml.isDocElement;
var parentElement   = eAu._Xml.parentElement;
var readAttribute   = eAu._Xml.readAttribute;
var writeAttribute  = eAu._Xml.writeAttribute;
var removeAttribute = eAu._Xml.removeAttribute;
//------------------------------------------------------------------------------
function getFetchOptions(option) {
	var Options = {
		descendants: false,
		srcAttr: opt.srcAttr,
		onFinish: function() {}
	};
	if (_.isString(option)) {
		Options.srcAttr = eAu.String.trim(option);
		if (Options.srcAttr == '') {
			return null;
		}
	} else if (option === false || option === true) {
		Options.descendants = option;
	} else if (option && !_.isEmpty(option)) {
		Options = _.extend(Options, option);
	}
	return Options;
}
//------------------------------------------------------------------------------
function getTraversalOptions(option) {
	var Options = {
		visible: true,
		offset: 1,
		type: []
	};
	if (_.isString(option)) {
		Options.type = eAu.String.trim(option).split(/\s+/);
	} else if (_.isArray(option)) {
		Options.type = option;
	} else if (_.isNumber(option)) {
		Options.offset = option || 0;
	} else if (option === false || option === true) {
		Options.visible = option;
	} else if (option && !_.isEmpty(option)) {
		Options = _.extend(Options, option || {});
	}
	Options.type = _.isString(Options.type)
		? eAu.String.trim(Options.type).split(/\s+/)
		: Options.type;
	Options.offset = Options.offset == 0 ? 1 : Options.offset;
	return Options;
}
//------------------------------------------------------------------------------
function getSelectOptions(option) {
	var Options = {
		single: false,
		extend: true
	};
	if (_.isString(option)) {
		Options.selector = option;
	} else if (option && !_.isEmpty(option)) {
		Options = _.extend(Options, option);
	}
	if (Options.selector) { Options.selector = eAu.String.trim(Options.selector); }
	return Options;
}
//------------------------------------------------------------------------------
function isGroupped(el) {
	var attr = readAttribute(el, opt.groupAttr);
	return attr !== 'false';
}
//------------------------------------------------------------------------------
function groupRoot(element) {
	// Проверка на Document Element не нужна,
	// т.к. parentElement вернёт null в качестве родителя
	var el = element;
	while (el && isVisible(el)) {
		el = parentElement(el);
		if (el && isGroupped(el)) { return el; }
	}
	return null;
}
//------------------------------------------------------------------------------
function groupRootGlobal(element) {
	var el = element;
	var root = null;
	while ( el && isVisible(el) ) {
		el = groupRoot(el);
		root = el ? el : root;
	}
	return root;
}
//------------------------------------------------------------------------------
function isOfType(el, types) {
	var isOfType = false;
	var selector, ElName, attrSelector;
	for (var i = 0, length = types.length; i < length; ++i) {
		ElName = name(el);
		if (types[i].indexOf('@') != -1) {
			selector = types[i].split('@');
			attrSelector = selector[1].split('=');
			isOfType = ((selector[0] == ElName)||(selector[0] == '*')) && (readAttribute(el, attrSelector[0]) == attrSelector[1]);
		} else {
			isOfType = (types[i] == '*') || (ElName == types[i]);
		}
		if (isOfType) { break; }
	}
	return (types.length == 0)
		? true
		: isOfType;
}
//------------------------------------------------------------------------------
function npElement(element, dir) {
	var el = element;
	do {
		el = el[dir + 'Sibling'];
		if (!isNode(el)) { return null; }
	} while ( !isElement(el) );
	return el;
}
//------------------------------------------------------------------------------
function npOfType(element, types, dir) {
	var el = element;
	do {
		el = npElement(el, dir);
	} while ( el && !isOfType(el, types) );
	return el;
}
//------------------------------------------------------------------------------
function npVisible(element, types, dir) {
	var el = element;
	do {
		el = npOfType(el, types, dir);
	} while ( el && !isVisible(el) );
	return el;
}
//------------------------------------------------------------------------------
function childElement(el, dir) {
	var start = (dir == 'previous') ? el.lastChild : el.firstChild;
	if (!isNode(start)) { return null; }
	return isElement(start) ? start : npElement(start, dir);
}
//------------------------------------------------------------------------------
function childOfType(el, types, dir) {
	var start = childElement(el, dir);
	if (!isElement(start)) { return null; }
	return isOfType(start, types) ? start : npOfType(start, types, dir);
}
//------------------------------------------------------------------------------
function childVisible(el, types, dir) {
	var start = childOfType(el, types, dir);
	if (!isElement(start)) { return null; }
	return isVisible(start) ? start : npVisible(start, types, dir);
}
//------------------------------------------------------------------------------
function np(element, options, dir) {
	var el = element;
	var offset = Math.abs(options.offset);
	var func = options.visible ? npVisible : npOfType;
	do {
		el = func(el, options.type, dir);
	} while ( el && --offset > 0 );
	return el;
}
//------------------------------------------------------------------------------
function child(element, options, dir) {
	var offset = Math.abs(options.offset);
	var el = options.visible
		? childVisible(element, options.type, dir)
		: childOfType(element, options.type, dir);
	var func = options.visible ? npVisible : npOfType;
	while ( el && --offset > 0 ) {
		el = func(el, options.type, dir);
	}
	return el;
}
//------------------------------------------------------------------------------
function collect(element, options, dir) {
	var offset = Math.abs(options.offset);
	var el = options.visible
		? childVisible(element, options.type, dir)
		: childOfType(element, options.type, dir);
	var func = options.visible ? npVisible : npOfType;
	while ( el && --offset > 0 ) {
		el = func(el, options.type, dir);
	}
	var collected = [];
	while ( el ) {
		collected.push(el);
		el = func(el, options.type, dir);
	}
	return collected;
}
//------------------------------------------------------------------------------
function index(el, child, options) {
	var childs = collect(el, options, 'next');
	return {
		length: childs.length,
		index: (_.indexOf(childs, child)+1)
	};
}
//------------------------------------------------------------------------------
function parentOfType(element, types) {
	var el = element;
	do {
		el = parentElement(el);
	} while ( el && !isOfType(el, types) );
	return el;
}
//------------------------------------------------------------------------------
function parent(el, options) {
	var parent = el;
	// Маленькая оптимизация
	var func = (options.type.length == 0) ? parentElement : parentOfType;
	while (options.offset > 0 && parent) {
		parent = func(parent, options.type);
		options.offset--;
	}
	return parent;
}
//------------------------------------------------------------------------------
function parentOrSelf(el, options) {
	var parent = el;
	if (options.type.length == 0) {
		while (options.offset > 0 && parent) {
			parent = parentElement(parent);
			options.offset--;
		}
		return parent;
	}
	if (isOfType(parent, options.type)) {
		options.offset--;
	}
	// Маленькая оптимизация
	while (options.offset > 0 && parent) {
		parent = parentOfType(parent, options.type);
		options.offset--;
	}
	
	return parent;
}
//------------------------------------------------------------------------------
function isVisibleIfMatters(el, visible) {
	return !visible || (visible && isVisible(el));
}
//------------------------------------------------------------------------------
function closest(el, options) {
	var parent = el;
	if (options.type.length == 0) {
		isVisibleIfMatters(parent, options.visible) && (parent = parentElement(parent));
	} else {
		while (parent && !isOfType(parent, options.type) && isVisibleIfMatters(parent, options.visible)) {
			parent = parentElement(parent);
		}
		//parent && !isOfType(parent, options.type) && (parent = null);
	}
	return parent;
}
//------------------------------------------------------------------------------
function name(el) {
	return el.nodeName.toLowerCase();
}
//------------------------------------------------------------------------------
function getRoot(el) {
	return el.ownerDocument;
}
//------------------------------------------------------------------------------
function addMethods(methods) {
	if (_.isArray(methods)) {
		for (var i = 0; i < methods.length; ++i) {
			addTagMethods(arguments[1], methods[i]);
		}
		return;
	}
	for (var name in methods) {
		if (_.isFunction(methods[name])) {
			XmlMethods[name] = methods[name];
		} else if (methods[name] && _.isEmpty(methods[name]) && name == 'ByTag') {
			addMethodsByTag(methods[name]);
		}
	}
}
//------------------------------------------------------------------------------
var XmlMethods = {
	name: function(element) {
		return name(element);
	},
	attr: function(element, attrName, attrValue) {
		var el = element;
		if (arguments.length == 2) {
			return readAttribute(el, attrName);
		} else if (arguments.length > 2) {
			return writeAttribute(el, attrName, attrValue)
		}
	},
	removeAttr: function (element, attrName) {
		return removeAttribute(element, attrName);
	},
	hasAttr: function(node, attrName) {
		if (node.hasAttribute) {
			return node.hasAttribute(attrName);
		} else {
			for (var i = 0, length = node.attributes.length; i < length; ++i) {
				if (node.attributes.item(i).name == attrName || node.attributes.item(i).nodeName == attrName) { return true; }
			}
		}
		return false;
	},
	next: function(element, options) {
		options = getTraversalOptions(options);
		if ( !(options.offset > 0) ) { return; }
		return np(element, options, 'next');
	},
	previous: function(element, options) {
		options = getTraversalOptions(options);
		if ( !(options.offset > 0) ) { return; }
		return np(element, options, 'previous');
	},
	neighbour: function(element, options) {
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return; }
		var dir = (options.offset > 0) ? 'next' : 'previous';
		return np(element, options, dir);
	},
	child: function(element, options) {
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return; }
		var dir = (options.offset > 0) ? 'next' : 'previous';
		return child(element, options, dir);
	},
	childs: function(element, options) {
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return; }
		// Пригодится, что-бы указывать отступ
		// с которого начинать поиск
		var dir = (options.offset > 0) ? 'next' : 'previous';
		var childs = collect(element, options, dir);
		return childs;
	},
	index: function(element, child, options) {
		if ( !child ) { return null; }

		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return null; }
		return index(element, child, options);
	},
	indexOf: function(element, child, options) {
		if ( !child ) { return -1; }
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return -1; }
		return index(element, child, options).index;
	},
	length: function(element, options) {
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return; }
		return index(element, eAu.undefined, options).length;
	},
	parent: function(element, options) {
		options = getTraversalOptions(options);
		return parent(element, options);
	},
	parentOrSelf: function(element, options) {
		options = getTraversalOptions(options);
		return parentOrSelf(element, options);
	},
	closest: function(element, options) {
		return closest(element, getTraversalOptions(options));
	},
	within: function (node, container, onlyVisible) {
		var child = node;
		
		if (!node || !container) { return false; }
		
		while (child && child.nodeType == 1) {
			if (child == container) {
				return true;
			} else if (onlyVisible && !isVisible(child)) {
				return false;
			}
			child = child.parentNode;
		}
		
		return false;
	},
	isRoot: function(element) {
		return isDocElement(element);
	},
	is: function(element, options) {
		if (!element) { return false; }
		return isOfType(element, getTraversalOptions(options).type);
	},
	select: function(element, options) {
		options = getSelectOptions(options);
		if ( !options.selector ) { return; }
		var elements = select(element, options);
		return elements;
	},
	_sCache: {},
	$: function(element, id, nodeName, bypassCache) {
		var selector = '//'+ (nodeName ? nodeName : '*') +'[@'+ opt.idAttr +' = "'+ id +'"]'
		  , ret
		  , rootUID = _Xml._getRootUID(element);

		if ( !id ) { return null; }
		if ( rootUID == null ) {
			throw new Error('hmmm');
		}
		_Xml._sCache[rootUID] || (_Xml._sCache[rootUID] = {});

		if (bypassCache) {
			ret = this.select(element, { single: true, selector: selector });
		} else {
			_Xml._sCache[rootUID][selector] || (_Xml._sCache[rootUID][selector] = this.select(element, { single: true, selector: selector }));
			ret = _Xml._sCache[rootUID][selector];
		}

		return ret;
	},
	id: function(element) {
		return this.attr(element, opt.idAttr);
	},
	safeId: function(element, prefix) {
		var id = _.isString(element) ? element : this.id(element);
		prefix = prefix || 'ID';
		if (id.charAt(0) == '{' && id.charAt(id.length - 1) == '}') {
			id = id.substr(1, id.length - 2);
		}
		return [prefix, id.replace(/-/g, '_'), 'EU'].join('_');
	},
	isVisible: function(element, checkParents) {
		return isVisible(element, !!checkParents);
	},
	isGroupped: function(element) {
		return isGroupped(element);
	},
	t: function(element) {
		return _Xml.title(element, true);
	},
	createElement: function(element, name) {
		if (!isElement(element) || !_.isString(name)) { return null; }
		return getRoot(element).createElement(name);
	},
	clone: function(element, copyChilds) {
		if (!isElement(element)) { return null; }
		return element.cloneNode(copyChilds === true);
	},
	title: function(element, Short, format) {
		var BaseTitle = eAu.String.trim(this.attr(element, 'title') || 'нет заголовка');
		var title = BaseTitle;
		if (_.indexOf(['text', 'object'], this.name(element)) != -1) {
			if (this.parent(element, 'glossary')) {
				title = eAu.String.trim(this.attr(element, 'title') || 'Глоссарий');
			} else {
				title = eAu.String.trim(this.attr(_Xml.parent(element), 'title') || 'нет заголовка');
				if (!this.isGroupped(_Xml.parent(element))) {
					var position = this.indexOf(_Xml.parent(element), element);
					var length = this.length(_Xml.parent(element));
					if (position != -1) {
						if (Short !== true) {
							if (length > 1) {
								if (format) {
									title += format.replace('%s', position).replace('%s', length);
								} else {
									title += ' (страница '+ position +' из '+ length +')';
								}
							}
						}
					} else if (BaseTitle == '') {
						title = '';
					} else {
						title = BaseTitle;
					}
				}
			}
		} else if (this.name(element) == 'studiedproblem'
			&& !this.isGroupped(element) && Short !== true) {
			var length = this.length(element);
			//if (length > 1) {
			//	title += ' (страница 1 из '+ length +')';
			//}
		} else if (/^(question|question-exercise)$/.test(this.name(element))) {
			title = eAu.String.trim(this.attr(_Xml.parent(element), 'title') || 'нет заголовка') + ' → ' + BaseTitle;
		}
		return title;
	},
	__roots:    [],
	_getRootUID: function (element) {
		var root = getRoot(element)
		  , index;
		if (!root || !(root = root.documentElement)) {
			return;
		}
		if ((index = _.indexOf(_Xml.__roots, root)) == -1) {
			index = _Xml.__roots.length;
			writeAttribute(root, 'uid', _.uniqueId('eau'));
			_Xml.__roots.push(root);
		}
		return readAttribute(_Xml.__roots[index], 'uid');
	},
	__promises: [],
	_getRootPromisesForElement: function (element) {
		var rootId = _Xml._getRootUID(element);
		if (rootId == null) {
			return {};
		}
		return _Xml.__promises[ rootId ] || (_Xml.__promises[ rootId ] = {});
	},
	getPromise: function (element) {
		var promises = _Xml._getRootPromisesForElement(element);
		return promises[_Xml.id(element)];
	},
	setPromise: function (element, promise) {
		var promises = _Xml._getRootPromisesForElement(element);
		if (promise == null) {
			removeAttribute(element, 'hasPromise');
		} else {
			writeAttribute(element, 'hasPromise', 'yes');
		}
		promises[_Xml.id(element)] = promise;
	},
	fetch: function(element, options) {
		if (!element) { return; }
		options = getFetchOptions(options);
		var el = element;
		var nodes = options.descendants
			? select(el, 'descendant-or-self::*[@'+options.srcAttr+' and not(@'+options.srcAttr+'="")]')
			: [el];
		nodes = _.compact(nodes);
		for (var i = 0, length = nodes.length; i < length; ++i) { (function (node, deferred) {
			var src = readAttribute(node, options.srcAttr)
			  , hasPromise = readAttribute(node, 'hasPromise') == 'yes';
			if (hasPromise || !src || !src.match(/(xml|php|json)$/i)) { return; }

			_Xml.setPromise(node, deferred.promise());
			
			eAu.preloader.add(src, function (data) {
				var promise = _Xml.getPromise(node);

				// Можем спокойно удалять это свойств, т.к. в случае, если __promise = null,
				// deferred становится автоматически resolved
				_Xml.setPromise(node, null);
				if (!data || !data.documentElement) {
					var TextNodeWithError = getRoot(el).createTextNode('<div class="eU-error"><h2 class="eU-error-title">Невозможно отобразить часть содержимого</h2><div class="eU-error-text">Неудалось загрузить файл "<code>'+ src +'</code>" с сервера. Обратитесь к администрации ресурса или в службу тех. поддержки для устранения неисправностей.</div></div>');
					var ElementWithErrorText = getRoot(el).createElement('root');
					
					ElementWithErrorText.appendChild(TextNodeWithError);
					Sarissa.copyChildNodes(ElementWithErrorText, node);
					
					deferred.reject();
				} else {
					removeAttribute(node, options.srcAttr);
					Sarissa.copyChildNodes(data.documentElement, node);
					
					deferred.resolve();
				}
			}, { id: _Xml.id(node) });
		})(nodes[i], jQuery.Deferred()); }
		return nodes;
	},
	when: function (/* nodes... */) {
		var args;
		args = _.compact(_.reduce(arguments, function (memo, arg) {
			if (_.isArray(arg)) {
				memo = memo.concat(arg);
			} else {
				memo.push(arg);
			}
			return memo;
		}, []));

		function getPromise (node) {
			var deferred = jQuery.Deferred()
			  , promise  = deferred.promise()
			  , nodes;
			
			nodes = select(node, 'descendant-or-self::*[@hasPromise = "yes"]');
			if (nodes.length) {
				$.when.apply($,
					_.map(nodes, function (node) { return _Xml.getPromise(node); })
				).then(function () {
					deferred.resolve();
				}, function () {
					deferred.reject();
				});
			} else {
				deferred.resolve();
			}
			
			return promise;
		}

		return $.when.apply($, _.map(args, getPromise));
	},
	text: function (node) {
		if (!_.isUndefined(node.text)) {
			return node.text;
		}
		var strings = [];
		for (var i = 0, ims = node.childNodes, length = node.childNodes.length; i < length; ++i) {
			if (ims.item(i).nodeType == 4 || ims.item(i).nodeType == 3) {
				strings.push(ims.item(i).nodeValue);
			} else if (ims.item(i).childNodes && ims.item(i).childNodes.length) {
				strings.push(this.text.call(this, ims.item(i)));
			}
		}
		return strings.join(' ');
	}
};
//------------------------------------------------------------------------------
XmlMethods.$$ = XmlMethods.select;
XmlMethods.item = XmlMethods.child;
XmlMethods.collect = XmlMethods.childs;
XmlMethods.create = XmlMethods.createElement;
//------------------------------------------------------------------------------
eAu.Xml = XmlMethods;
self._Xml = eAu.Xml;

})();

(function () {
"use strict";

function merge (left, right, comparison) {
	var result = [];
	while ((left.length > 0) && (right.length > 0)) {
		if (comparison(left[0], right[0]) <= 0)
			result.push(left.shift());
		else
			result.push(right.shift());
	}
	while (left.length > 0)
		result.push(left.shift());
	while (right.length > 0)
		result.push(right.shift());
	return result;
}
function merge_sort (array, comparison) {
	var middle;
	if (array.length < 2)
		return array;
	middle = Math.ceil(array.length / 2);
	return merge(
		merge_sort(array.slice(0, middle), comparison),
		merge_sort(array.slice(middle), comparison),
		comparison
	);
}

var eAuNav;
var rootsCache = {};

function dfs (root, filter, substitution) {
	return _dfs_re(
		  [root]
		, filter
		, substitution
		, root
		, { seq_raw: [], seq_boat: [], seq: [], idx_raw: {}, idx: {} }
	);
}

function _dfs_re (items, filter, substitution, root, out) {
	var f_ret
	  , current
	  , current_id
	  , subst
	  , subst_idx;
	
	for (var i = 0, length = items.length; i < length; ++i) {
		current = items[i];
		current_id = _Xml.id(current);
		
		if (out.idx_raw[current_id]) {
			// that's bad, a dup ID
			throw new Error('There is a dup DB_ID in tree: "' + current_id + '"');
		}
		
		f_ret = parseInt(filter(current, root), 10) || 0;
		
		out.seq_raw.push(current);
		out.seq_boat.push(current);
		out.idx_raw[current_id] = {
			real:   out.seq_raw.length - 1,
			unreal: out.seq_boat.length - 1,
			inseq:  out.seq.length - 1
		};
		
		// something like second subject
		if (f_ret & eAuNav.DFS_VIRTUAL_DUP) {
			subst = substitution(current, root);
			if ( subst && (~ (subst_idx = _.lastIndexOf(out.seq, subst))) ) {
				out.idx_raw[current_id].inseq = subst_idx;
			}
		}

		if (f_ret & eAuNav.DFS_INCLUDE_SELF) {
			out.seq.push(current);
			out.idx[current_id] = out.seq.length - 1;
		}
		
		if (f_ret & eAuNav.DFS_INCLUDE_CHILDS) {
			_dfs_re(_Xml.collect(current), filter, substitution, root, out);
			out.seq_boat.push(current);
		}
	}
	
	return out;
}

function localVisibleRoot (element, stopNode) {
	var el = element;
	while ( el && eAu._Xml.isVisible(el) && !(eAu._Xml.isDocElement(el) || el == stopNode) ) {
		el = eAu._Xml.parentElement(el);
	}
	return el;
}

function defaultSubstitutionFunction (current, root) {
	var nodeName = _Xml.name(current);
	
	if ( ~ _.indexOf(['subject', 'references'], nodeName) ) {
		return _Xml.previous(current, 'subject references');
	}
}

function defaultFilterFunction (current, root) {
	var bitf = 0;
	var nodeName = _Xml.name(current);
	var containers = ['studiedproblems', 'lesson', 'unit', 'study-modules'];
	var leafs = ['studiedproblem', 'test', 'text', 'object', 'subject', 'references'];
	// don't include self
	// include childs
	if ( ~ _.indexOf(containers, nodeName) ) {
		bitf |= eAuNav.DFS_INCLUDE_CHILDS;
	}

	// include self
	// don't include childs
	if ( ~ _.indexOf(leafs, nodeName) ) {
		bitf |= eAuNav.DFS_INCLUDE_SELF;
	}

	// special case for studiedproblem
	if (nodeName == 'studiedproblem' && !_Xml.isGroupped(current)) {
		bitf &= ~eAuNav.DFS_INCLUDE_SELF;
		bitf |= eAuNav.DFS_INCLUDE_CHILDS;
	}
	
	// special case for subjects, references
	if (nodeName == 'subject' || nodeName == 'references') {
		if (_Xml.previous(current, 'subject references')) {
			bitf &= ~eAuNav.DFS_INCLUDE_SELF;
			bitf &= ~eAuNav.DFS_INCLUDE_CHILDS;
			bitf |= eAuNav.DFS_VIRTUAL_DUP;
		}
	}

	return bitf;
}


function defaultSliderFilterFunction (current, root, depth) {
	var bitf = 0;
	var nodeName = _Xml.name(current);
	var unbreakable  = ['studiedproblems', 'studiedproblem', 'test', 'text', 'object', 'subject', 'references'];
	var depth_sp     = ['studiedproblem', 'test', 'subject', 'references'];
	var depth_spchld = ['test', 'text', 'object', 'subject', 'references'];
	
	if ( ~ _.indexOf(unbreakable, nodeName) ) {
		bitf |= (eAuNav.SLIDER_SEARCH_FORWARD | eAuNav.SLIDER_SEARCH_BACKWARD);
	}
	
	if ((depth & eAuNav.SLIDER_DEPTH_SP) && ( ~ _.indexOf(depth_sp, nodeName))) {
		bitf |= eAuNav.SLIDER_INCLUDE_SELF;
	}
	
	if ((depth & eAuNav.SLIDER_DEPTH_SPCHLD) && ( ~ _.indexOf(depth_spchld, nodeName))) {
		bitf |= eAuNav.SLIDER_INCLUDE_SELF;
	}
	
	// special case for subjects, references
	if (nodeName == 'subject' || nodeName == 'references') {
		if (_Xml.previous(current, 'subject references')) {
			bitf &= ~eAuNav.SLIDER_INCLUDE_SELF;
		}
	}
	
	return bitf;
}

function getClosestInSeq (el, dfs_list) {
	var element_id = _Xml.id(el);
	
	while (el && el.nodeType != 9 && el.nodeType != 11 && _.isUndefined(dfs_list.idx_raw[_Xml.id(el)])) {
		el = el.parentNode;
	}
	
	if (!el || _.isUndefined(dfs_list.idx_raw[_Xml.id(el)]) || el.nodeType == 9 || el.nodeType == 11) {
		return null;
	}
	
	return el;
}

eAu.navigation = eAu.nav_temp = eAuNav = {
	neighbours: function (element) {
		var dfs_list = this._get(element)
		  , result = { next: null, prev: null }
		  , element_id
		  , el = element
		  , index;
		// ooops
		if (dfs_list === false || !element) {
			return result;
		}
		
		// если элемент отсутствует в idx_raw значит мы его не обходили,
		// т.е. он чей-то потомок
		element = getClosestInSeq(element, dfs_list);
		if (!element) {
			return result;
		}
		element_id = _Xml.id(element);
		
		if (!_.isUndefined(dfs_list.idx[element_id])) {
			index = dfs_list.idx[element_id];
		} else {
			index = dfs_list.idx_raw[element_id].inseq;
		}
		dfs_list.seq[index + 1] && (result.next = dfs_list.seq[index + 1]);
		dfs_list.seq[index - 1] && (result.prev = dfs_list.seq[index - 1]);
		
		return result;
	},
	slider: function (element, depth) {
		var dfs_list = this._get(element)
		  , result = { list: [], current: -1 }
		  , element_id
		  , el = element
		  , index;
		
		if (dfs_list === false || !element) {
			return result;
		}
		
		element = getClosestInSeq(element, dfs_list);
		if (!element) {
			return result;
		}
		element_id = _Xml.id(element);
		depth || (depth = eAuNav.SLIDER_DEPTH_SP);
		
		if (!_.isUndefined(dfs_list.idx[element_id])) {
			index = dfs_list.idx[element_id];
		} else {
			index = dfs_list.idx_raw[element_id].inseq;
		}
		
		var start = dfs_list.idx_raw[element_id].unreal + 1
		  , stop  = dfs_list.idx_raw[element_id].unreal
		  , real = {}
		  , realIndex
		  , itemId
		  , item
		  , bitf;

		while (item = dfs_list.seq_boat[start-- - 1]) {
			bitf = defaultSliderFilterFunction(item, null, depth);
			if (!(bitf & eAuNav.SLIDER_SEARCH_BACKWARD)) { break; }
			itemId    = _Xml.id(item);
			realIndex = dfs_list.idx_raw[itemId].real;
			if (!real[realIndex] && (bitf & eAuNav.SLIDER_INCLUDE_SELF)) {
				result.list.unshift(
					_.extend({}, dfs_list.idx_raw[itemId], { item: item })
				);
			}
			if (!real[realIndex]) {
				real[realIndex] = true;
			}
		}
		result.current = result.list.length - 1;
		while (item = dfs_list.seq_boat[stop++ + 1]) {
			bitf = defaultSliderFilterFunction(item, null, depth);
			if (!(bitf & eAuNav.SLIDER_SEARCH_FORWARD)) { break; }
			itemId    = _Xml.id(item);
			realIndex = dfs_list.idx_raw[itemId].real;
			if (!real[realIndex] && (bitf & eAuNav.SLIDER_INCLUDE_SELF)) {
				result.list.push(
					_.extend({}, dfs_list.idx_raw[itemId], { item: item })
				);
			}
			if (!real[realIndex]) {
				real[realIndex] = true;
			}
		}
		
		result.list = _.pluck(merge_sort(result.list, function (left, right) {
			return (left.inseq - right.inseq);
		}), 'item');
		
		return result;
	},
	_get: function (element) {
		var container
		    , root
		    , root_id
		    , dfs_res;
		if (!element) { return false; }

		// Сначала найдём корень
		container = _Xml.parentOrSelf(element, 'study-modules appendix-item');

		// Возможно это intro или чо-то ещё
		if (!container) { return false; }

		root = localVisibleRoot(element, container);

		// Такого не должно быть, но если вдруг, то надо понять почему :)
		if (!root) {
			throw new Error("Ooops in nav_temp.init");
			return false;
		}

		root_id = _Xml.id(root);
		if (_.isUndefined(rootsCache[root_id])) {
			rootsCache[root_id] = dfs(root, defaultFilterFunction, defaultSubstitutionFunction);
		}
		return rootsCache[root_id];
	}
};
_.extend(eAuNav, {
	DFS_INCLUDE_SELF:    (1 << 0),
	DFS_INCLUDE_CHILDS:  (1 << 1),
	DFS_VIRTUAL_DUP:     (1 << 2),
	SLIDER_DEPTH_SP:     (1 << 10),
	SLIDER_DEPTH_SPCHLD: (1 << 11),
	SLIDER_INCLUDE_SELF: (1 << 20),
	SLIDER_SEARCH_FORWARD: (1 << 21),
	SLIDER_SEARCH_BACKWARD: (1 << 22)
});

})();

function getLocalFilename(filename) {
	if (filename.indexOf('://') != -1) {
		return filename;
	}
	var dlh = document.location.pathname.replace(/\\/g, '/').split('/');
	filename = (filename || '').replace(/\\/g, '/').split('/')
	dlh.pop();
	dlh = dlh.concat(filename);
	dlh = _.map(_.map(_.without(dlh, '.'), decodeURIComponent), encodeURIComponent);
	return document.location.protocol + '//' + document.location.host + dlh.join('/');
}

function inDOM() {
	return !!_Xml.parentOrSelf(this, 'body');
}

function attachDOM3EventOnNodeInsertedAddHandler(event) {
	var node = event.target;
	if (node && node.onload) {
		node.onload.call(node);
	}
}
function attachDOM3EventOnNodeInsertedRemoveHandler(event) {
	var node = event.target;
	if (!node) { return; }
	
	node.removeEventListener('DOMNodeInsertedIntoDocument', attachDOM3EventOnNodeInsertedAddHandler, true);
	node.removeEventListener('DOMNodeRemovedFromDocument', attachDOM3EventOnNodeInsertedRemoveHandler, true);
}

function attachDOM3EventOnNodeInserted() {
	if (!this.addEventListener || inDOM.call(this)) { return; }
	
	this.addEventListener('DOMNodeInsertedIntoDocument', attachDOM3EventOnNodeInsertedAddHandler, true);
	this.addEventListener('DOMNodeRemovedFromDocument', attachDOM3EventOnNodeInsertedRemoveHandler, true);
}

function transformToTextEx(element, stylesheet, options) {
	if (!stylesheet) { return; }

	stylesheet.clearParameters();
	options = _.extend({
		'transformed-element-id': _Xml.id(element)
	}, options || {});

	for (var param in options) {
		if (!_.isString(options[param]) || !param) { continue; }
		stylesheet.setParameter(null, param, options[param]); 
	}
	
	var output;
	try {
		output = stylesheet.transformToFragment(element.ownerDocument.documentElement, document);
	} catch (error) {
		return;
	}

	if (output && output.firstChild) {
		var fc = output.firstChild;
		output = document.createElement('div');
		output.appendChild(fc);
	} else {
		output = null;
	}

	try {
		if (output) {
			return Sarissa.unescape(output.innerHTML);
		} else {
			return;
		}
	} finally {
		output = null;
	}
}

function findParentOrSelfTarget (node, nodeName, level) {
	function isNodeName(n) {
		return !!n && (n.nodeName.toLowerCase() === (nodeName || '').toLowerCase());
	}
	level = (_.isNumber(level) && !_.isNaN(level) && level > 0) ? level : 5;
	var target = node,
	    i = 0;

	if (!target || !nodeName)
		return null;
	while (target || i < 5) {
		++i;
		if (isNodeName(target)) break;
		target = _Xml.parent(target);
	}
	if (!target || !isNodeName(target))
		return null;
	return target;
}

// Обработка внутренних ссылок
function isEventCanceled (event) {
	return event.isPropagationStopped() || event.isImmediatePropagationStopped() || event.result === false;
}

function checkLink (event) {
	var target = findParentOrSelfTarget(event.target, 'a')
	  , $target = $(target)
	  , linkId
	  , isInnerLink
	  , element
	  , targetNode
	  , suffix
	  , isAccessible;

	if (target) {
		if (_Xml.attr(target, 'InnerLink')) {
			isInnerLink = true;
			linkId = (_Xml.attr(target, 'InnerLink') + '').replace(/^EUL:/, '');
		} else if (_Xml.attr(target, 'db-id')) {
			linkId = _Xml.attr(target, 'db-id');
		}
		suffix = isInnerLink ? '-inner-link' : '-link';

		if (linkId) {
			element = _Xml.$(head, linkId);
			isAccessible = !!element && checkRights(element) && canNavigateToNodeOnServer(element);
			targetNode = element ? getTargetNode(element) : null;

			$target
				.attr('href', 'index.htm')
				.attr('target', '_top');

			if (!$target.is('.eAu' + suffix))
				$target.addClass('eAu' + suffix);

			if (targetNode && !$target.is('.eAu-' + _Xml.name(targetNode) + suffix)) {
				$target.addClass('eAu-' + _Xml.name(targetNode) + suffix);
			}

			$target.attr('title', element ? _Xml.title(element) + (isAccessible ? '' : ' [раздел недоступен]') :  'Раздел не найден');

			if (isAccessible && $target.is('.eAu-access-forbidden' + suffix)) {
				$target.removeClass('eAu-access-forbidden' + suffix);
			}
			if (!isAccessible && !$target.is('.eAu-access-forbidden' + suffix)) {
				$target.addClass('eAu-access-forbidden' + suffix);
			}
			
			if (!isInnerLink && /(mousedown|mouseup|click)$/i.test(event.type)) {
				event.preventDefault();
				/*if (isAccessible && !isEventCanceled(event))
					link_info(linkId);*/
			}
		}
	}
}
