self.QParams = eAu.String.toQueryParams(document.location.search.toString());
self.$window = $(window);

// Some global user settings
eAu.UOptions.globalContent = true;

var use_internal_navigation_els = true;
var block_content_copy      = false;
var isELS = false;
var courseXml = 'course.json'
try {
	nFindMetadataTries = 0;
	win = window.parent;
	while ((win.eLearning_server_metadata == null || typeof win.eLearning_server_metadata == 'undefined')
		  && (win.parent != null)
		  && (win.parent != win)) {
		nFindMetadataTries ++;
		if (nFindMetadataTries > 500) { break; }
		win = win.parent;
	}
	if (typeof win.eLearning_server_metadata != 'undefined') {
		isELS = true;
		if (!!win.eLearning_server_metadata.coursexml && win.eLearning_server_metadata.coursexml != '') {
			courseXml = win.eLearning_server_metadata.coursexml;
		}
		use_internal_navigation_els = win.eLearning_server_metadata.course_options.use_internal_navigation
		block_content_copy = win.eLearning_server_metadata.course_options.block_content_copy
	}
} catch (error) {}

if (typeof self.QParams['db'] == 'string') {
	courseXml = self.QParams['db']
}

var xsls = [["commonXSL", "common.xsl"], ["printXsl", "print.xsl"]];

function getSupportedExtensions() {
	var supportedExtensions = [];

	if (navigator.plugins && navigator.plugins.length > 0) {
		supportedExtensions = ['png', 'gif', 'jpg', 'jpeg', 'bmp', 'html', 'htm', 'mht', 'swf'];
		var extensionsLength = navigator.plugins.length;
		var plugs = navigator.plugins;
		for (var i = 0; i < extensionsLength; ++i) {
			var plug = plugs[i];
			for (var j = 0; j < plug.length; ++j) {
				if (!plug[j].enabledPlugin) { continue; }
				var suffixes = (plug[j].suffixes || '').split(',');
				for (var k = 0; k < suffixes.length; ++k) {
					var suffix = eAu.String.trim(suffixes[k] || '');
					if (suffix && suffix != '*') {
						supportedExtensions.push(suffix.toLowerCase());
					}
				}
			}
		}
	}

	return supportedExtensions;
}

var head, courseDataLoaded = false;

function backCounter() {
	var ac = arguments.callee;
	if (_.isUndefined(ac.documentsLeft)) {
		ac.documentsLeft = 1 + xsls.length;
	}
	if (--ac.documentsLeft == 0) {
		_.defer(function () {
			$window.trigger('course:data-loaded');
		});
	}
}
// Bind events to window object
// Эти события должны быть самыми последними, т.к. 
// после их отработки выставляется флаг, что курс
// загружен и внутренний фрейм начинает выполнять код
$window
	.one('course:data-loaded', function(event) {
		courseDataLoaded = true;
	})
	.one('course:xml-loaded', backCounter)
	.bind('course:xsl-loaded', backCounter)
	.one('course:load-error', function(event) {
		$window.trigger('course:data-loaded', {error: true});
	});

_.delay(function () {

eAu.preloader.add(courseXml, function(data) {
	if (!data || !data.documentElement) {
		$window.trigger('course:load-error', {file: courseXml, type: 'xml'});
		return;
	}

	head = data.documentElement;

	var Objects = _Xml.select(head, '//object[@src or @src-external]');
	for (var i = 0; i < Objects.length; ++i) {
		var O = Objects[i];

		var src = O.getAttribute('src');
		try {
			O.setAttribute('xslt-src', decodeURI(src.replace(/'/g, "\\'")));
		} catch (error) {}

		var Width = parseInt(O.getAttribute('width'), 10);
		var Height = parseInt(O.getAttribute('height'), 10);

		if (!Width || Width < 0) {
			O.setAttribute('width', '0');
		}
		if (!Height || Height < 0) {
			O.setAttribute('height', '0');
		}

		if (_Xml.parent(O, 'references')) {
			_Xml.attr(O, 'default', 'false');
		}

		if (_Xml.attr(O, 'external') == 'yes' && _Xml.attr(O, 'src-external')) {
			_Xml.attr(O, 'type', 'external');
			var srcExternal = _Xml.attr(O, 'src-external');
			if (/youtube\.com\/watch\?/.test(srcExternal)) {
				srcExternal = eAu.String.toQueryParams(srcExternal);
				if (srcExternal.v) {
					_Xml.attr(O, 'src', (/^file/.test(window.location.protocol) ? 'http:' : '') + '//www.youtube.com/embed/'+ encodeURIComponent(srcExternal.v));
				}
			}
		} else {
			var SplittedSrc = src.split('/');
			var filename = SplittedSrc.pop();
			O.setAttribute('filename', filename);
			O.setAttribute('base-src', decodeURI(SplittedSrc.join('/')));

			var supportedExtensions = getSupportedExtensions();
			if (supportedExtensions.length) {
				var extension = filename.split('.').pop();
				if (extension && _.indexOf(supportedExtensions, extension.toLowerCase()) == -1) {
					O.setAttribute('eAu-supported-extension', 'false');
					O.setAttribute('eAu-filename-extension', extension.toLowerCase());
				}
			}
		}
	}

	document.title = _Xml.title(head);
	$window.trigger('course:xml-loaded');
}, { id: 'course.xml' });

_.each(xsls, function(val, i) {
	eAu.preloader.add("xslt/"+ (/\.json/i.test(courseXml) ? val[1].replace(/\.xsl/i, '.json') : val[1]), function(data) {
		if (!data) {
			$window.trigger('course:load-error', {file: val[1], type: 'xsl'});
			return;
		}
		window[val[0]] = data;
		$window.trigger('course:xsl-loaded');
	}, { id: val[1] });
});

}, 1000);

var printWindow = null;
var objectWindow = null;

var viewedItems = {};
