eAu.TestUI = {};
/* BEGIN: вспомогательные функции теста */
;(function() {
"use strict";

var TEST_FINISH_STATUS_NORMAL    = 1,
    TEST_FINISH_STATUS_SKIP      = 3, // Прервать тестирование
    TEST_FINISH_STATUS_INTERRUPT = 4, // Досрочно завершить тестирование с выставлением оценки
    TEST_FINISH_STATUS_TIMEOUT   = 5;
var QUESTION_STATUS_TIMEOUT = 105,
    QUESTION_STATUS_SKIP    = 103,
    QUESTION_STATUS_ANSWER  = 101;

// TODO: refactor
function gettext_n_chooser (number) {
	return arguments[gettext_n_index(number) + 1];
}

function gettext_n (number, word) {
	var words = {
		'балл': ['баллов', 'балл', 'балла'],
		'процент': ['процентов', 'процент', 'процента'],
		'возможность': ['возможных', 'возможного', 'возможных'],
		'вопрос': ['вопросов', 'вопрос', 'вопроса'],
		'секундa': ['секунд', 'секунда', 'секунды'],
		'минута': ['минут', 'минута', 'минуты'],
		'попытка': ['попыток', 'попытку', 'попытки'],
		'элемент': ['элементов', 'элемент', 'элемента'],
		'ответ': ['ответов', 'ответ', 'ответа']
	};
	return words[word]
		? gettext_n_chooser.apply(null, [Math.floor(number)].concat(words[word]))
		: word;
}

function inflectWord (number, word, template) {
	var ac = inflectWord;
	ac.template = ac.template || _.template('<%= number %> <%= word %>');
	template = template || ac.template;
	
	return template({
		'number': number,
		'word': gettext_n(number, word)
	});
}

function inflectTimeString (time, countdown) {
	var secondsLeft = Math.floor(time / 1000),
	    minutesLeft = Math.floor(time / 1000 / 60),
	    timeLeft = minutesLeft == 0 ? secondsLeft : minutesLeft,
	    word = minutesLeft == 0 ? 'секундa' : 'минута',
	    ac = inflectTimeString;
	
	ac.template = ac.template || _.template('<%= countdown %> <span class="eAu-timer-stat"><%= time %></span> <%= word %>');
	
	return ac.template({
		'countdown': countdown ? 'осталось' : 'прошло',
		'time': timeLeft,
		'word': gettext_n(timeLeft, word)
	});
}

// TODO: постараться избавиться или унифицировать
function get_return_link () {
	return (DS.has('parentId')
	  ? '<a href="index.htm" db-id="'+ DS.get('parentId') +'" onclick="return false;" target="_top" title="Вернуться к основному содержимому"><img border="0" src="images/return.gif" width="18" height="18" align="absmiddle" hspace="7" /></a>'
	  : ''
	);
}

function interruptQuestionTimers (Test) {
	_.invoke(Test.queue.get(), 'timer', 'interrupt');
}

// Функции форматирования строки
// TODO: можно вынести в отдельную либу
function gettext_n_index (number) {
	if ( (number % 100 >= 11 && number % 100 <= 19) || (number % 10 >= 5 && number % 10 <= 9) || number % 10 == 0 ) {
		return 0;
	} else if (number % 10 == 1) {
		return 1;
	}
	return 2;
}

function loadExerciseObjectDimensions (objectNode) {
	if (!objectNode || _Xml.attr(objectNode, 'eAu-exercise-dimensions-set')) {
		return;
	}
	
	var exerciseCourseXml = _Xml.attr(objectNode, 'src') || '';
	exerciseCourseXml = exerciseCourseXml.split('/');
	exerciseCourseXml.pop();
	exerciseCourseXml.push('course.xml');

	// TODO: make ASYNC (с помощь события)
	eAu.preloader.add(exerciseCourseXml.join('/'), function(data) {
		if (!data || !data.documentElement || !/^test$/.test(_Xml.name(data.documentElement))) {
			return;
		}
		var screens = _Xml.collect(data.documentElement, 'screen');
		var maxWidth = parseInt(_Xml.attr(data.documentElement, 'width'), 10);
		var maxHeight = parseInt(_Xml.attr(data.documentElement, 'height'), 10);
		for (var scrI = 0; scrI < screens.length; ++scrI) {
			var w = parseInt(_Xml.attr(screens[scrI], 'width'), 10);
			var h = parseInt(_Xml.attr(screens[scrI], 'height'), 10);
			if (w > maxWidth)  maxWidth = w;
			if (h > maxHeight) maxHeight = h;
		}
		_Xml.attr(objectNode, 'width', maxWidth ? maxWidth : '800');
		_Xml.attr(objectNode, 'height', maxHeight ? maxHeight : '600');
	});
	_Xml.attr(objectNode, 'eAu-exercise-dimensions-set', 'true');
}

function prepareQuestionNode (Question) {
	var random = Question['shuffleAnswers']
	  , ClonedNode = Question['xmlNode'].cloneNode(true)
	  , ClonedAnswersNode = _Xml.child(ClonedNode, 'answers')
	  , ClonedChildNodes
	  , ClassGroups;
	
	if (/^exercise$/.test(Question['type'])) {
		loadExerciseObjectDimensions(_Xml.child(Question['xmlNode'], 'object'));
	} else if (/^classify$/.test(Question['type'])) {
		ClassGroups = eAu.Array.shuffle(_.reduce(Question['answerNodes'], function (memo, answer) {
			var classGroup = (_Xml.attr(answer, 'class-group') || '');
			if (_.indexOf(memo.terms, classGroup.toLowerCase()) == -1) {
				memo.terms.push(classGroup.toLowerCase());
				memo.groups.push(_Xml.createElement(answer, 'class-group'));
				_Xml.attr(_.last(memo.groups), 'class-group-id', _Xml.attr(answer, 'class-group-id'));
				_Xml.attr(_.last(memo.groups), 'class-group', classGroup);
			}
			return memo;
		}, { terms: [], groups: [] }).groups);
	}
	
	if (random && ClonedAnswersNode) {
		ClonedChildNodes = eAu.Array.shuffle(_Xml.collect(ClonedAnswersNode, 'answer object'));
		// TODO: check
		//Sarissa.clearChildNodes(ClonedAnswersNode);
		for (var i = 0, length = ClonedChildNodes.length; i < length; ++i) {
			ClonedAnswersNode.appendChild(ClonedChildNodes[i]);
		}
	}

	if (ClassGroups) {
		for (var i = 0, length = ClassGroups.length; i < length; ++i) {
			ClonedNode.appendChild(ClassGroups[i]);
		}
	}

	return ClonedNode;
}

function prepareAnswersForDD (Q, A) {
	var O = Q.options
	  , RA = Q.rightAnswer
	  , filteredRightAnswers;
	Q.options.dd && ( filteredRightAnswers = _(Q.rightAnswer).reduce(function (memo, ra, id) {
		if (Q.options.dd[id]) {
			memo[id] = ra;
		}
		return memo;
	}, {}) );
	return _([O.stubs || [], O.perAnswerStubs[_Xml.id(A)] || [], _(filteredRightAnswers || RA).values()]).chain()
		.flatten()
		.filter(function filter (a) {
			Q.options.matchCase || (a = a.toLowerCase());
			filter.f || (filter.f = {})
			if (filter.f[a]) return false
			filter.f[a] = true;
			return true;
		}).value();
}

var QHtml = {
	compare: function (Q) {
		return QHtml.fillingaps.apply(QHtml, arguments);
	},
	fill: function (Q) {
		return QHtml.fillingaps.apply(QHtml, arguments);
	},
	single: function (QuestionHash) {
		var $QuestionHtmlNode = $(document.getElementById('eAu-question-'+ QuestionHash['id']));
		$QuestionHtmlNode.bind('mouseup.question-type-single', function (event) {
			var $target = $(event.target).closest('.eAu-answer-variant-cell')
			    , node;
			if (!$target.length) { return; }
			node = $target
				.closest('.eAu-question-answer-item')
				.find('.eAu-answer-input-cell input')
				.get(0);
			if (node && !node.disabled) {
				node.checked = !node.checked;
			}
		});
		$window.one('eAu:test:question:answer eAu:test:question:skip', function (event, Test, Question) {
			if (QuestionHash['id'] == Question['id']) {
				$QuestionHtmlNode.unbind('mouseup.question-type-single');
			}
		});
	},
	multiple: function (QuestionHash) {
		return this.single.apply(this, arguments);
	},
	classify: function (QuestionHash) {
		var QSafeId = _Xml.safeId(QuestionHash['xmlNode']);
		$('div.eAu-sortable-'+ QSafeId).sortable({
			axis: 'y',
			connectWith: 'div.eAu-sortable-'+ QSafeId,
			stop: function(event, ui) {
				ui.item[0].style.opacity = '';
				ui.item[0].style.filter = '';
			}
		});
	},
	sort:  function (QuestionHash) {
		var QSafeId = _Xml.safeId(QuestionHash['xmlNode']);
		$('div.eAu-sortable-'+ QSafeId).sortable({
			axis: 'y',
			stop: function(event, ui) {
				ui.item[0].style.opacity = '';
				ui.item[0].style.filter = '';
			}
		});
	},
	fillingaps: function (Q, stage) {
		var QNode = document.getElementById('eAu-question-' + Q.id)
		  , answerIds
		  , noneSelectedText = '&nbsp;'
		  , allAnswers
		  , $uis;
		
		if (!QNode) { return; }

		if (Q.type == 'fillingaps')
			$uis = $(QNode).find('.eAu-question-text [InnerLink]');
		else
			$uis = $(QNode).find('.eAu-question-answers input[is-gap="yes"], .eAu-question-answers select[is-gap="yes"]');

		// hash, to filter gaps which points to non-answer node
		answerIds = _.reduce(Q.answerNodes, function (memo, ans) {
			return (memo[_Xml.id(ans)] = ans, memo);
		}, {});

		if (stage == 'eAu:content:afterchange' && Q.type == 'fillingaps') {
			$uis.each(function () {
				var dbid = (this.getAttribute('InnerLink') || $(this).data('dbid') || '').replace(/^EUL:/, '');
				if (answerIds[dbid]) {
					$(this).addClass('eAu-question-answers-hidden');
				}
			});
			return;
		}

		$uis.each(function () {
			var dbid = (this.getAttribute('InnerLink') || $(this).data('dbid') || '').replace(/^EUL:/, '')
			  , $this = $(this)
			  , $replacement
			  , showAsDD
			  , options
			  , width;

			if (!answerIds[dbid]) return;

			showAsDD = $this.is('select') || (!_.isUndefined(Q.options.dd) && Q.options.dd[dbid]) || $this.data('dd');
			width = $this.innerWidth();

			if ( showAsDD ) {
				allAnswers = prepareAnswersForDD(Q, answerIds[dbid]);
				$replacement = $('<select size="1"></select>');
				options = _(eAu.Array.shuffle(allAnswers)).map(function (a) {
					return '<option value="'+ a +'" val="'+ a +'" '+(!a?'style="font-style: italic;"':'')+'>'+ (a||'пустое значение') +'</option>';
				});
				if (!$.fn.multiselect)
					options.unshift('<option>'+ noneSelectedText +'</option>');
				$replacement.html(options.join(''));
			} else {
				$replacement = $('<input type="text">');
			}
			$replacement
				.css('width', width > 50 ? width : 50)
				.attr('name', _Xml.safeId(dbid, 'gap'))
				.attr('is-gap', 'yes')
				.data({ dbid: dbid });
			$this.replaceWith($replacement);
			if ( showAsDD ) {
				if (Q.options.multiple[dbid])
					$replacement.attr('multiple', 'multiple');
				else
					$replacement.removeAttr('multiple', 'multiple');
				if ($.fn.multiselect)
					$replacement.get(0).selectedIndex = -1;
				else
					$replacement.get(0).selectedIndex = 0;

				$.fn.multiselect && $replacement.multiselect({
					header: false,
					multiple: Q.options.multiple[dbid],
					minWidth: width > 150 ? width : 150,
					beforeopen: function () {
						var $empty = $(this).multiselect("widget").find(":checkbox, :radio").filter("[value='']");
						if (!$empty.next().is('em'))
							$empty.next().wrap('<em></em>');
						$(this).multiselect('widget').css('width', 300);
					},
					selectedText: function (n, N, opts) {
						if (opts.length <= 1) {
							return _(opts).reduce(function (memo, opt) {
								return (memo.push(opt.value || '<em>пустое значение</em>'), memo);
							}, []).join(', ')
						} else {
							return 'выбрано ' + inflectWord(n, 'ответ');
						}
					},
					noneSelectedText: noneSelectedText
				});
			}
		});
		
		if (stage == 'eAu:content:afterchange:animation-complete' && Q.type == 'fillingaps') {
			$uis.removeClass('eAu-question-answers-hidden');
		}
	}
}

function prepareQuestionHTML (QuestionHash, stage) {
	var QType = QuestionHash['type'];
	if ( !_.isFunction( QHtml[QType] ) || (stage == 'eAu:content:afterchange' && QHtml[QType].length < 2) ) {
		return;
	}
	QHtml[QType](QuestionHash, stage);
}

function loadTestNavInfo (CurrentTest, Questions) {
	var isLast = CurrentTest.queue.isLast(),
	    ac = loadTestNavInfo;
	ac.template = ac.template || _.template('<span class="eAu-test-questions-stat"><%= number %></span> <%= word %>');
	
	// Отображаем параметры теста в целом
	$('#eAu-test-questions-statistics')
		.html('осталось ' + inflectWord(CurrentTest.queue.getLeft(), 'вопрос', ac.template) + ', всего ' + inflectWord(CurrentTest.queue.getLength(), 'вопрос', ac.template));

	if (CurrentTest.isInterruptAllowed()) {
		$('#eAu-test-interrupt > a')
			.bind('click', function (event) {
				$window.trigger('eAu:test:interrupt:request', [CurrentTest])
				return false;
			})
			.parent()
			.show();
	} else {
		$('#eAu-test-interrupt').hide();
	}
	$('#eAu-test-skip > a')
		.bind('click', function (event) {
			$window.trigger('eAu:test:skip:request', [CurrentTest]);
			return false;
		})
		.parent()
		.show();
	
	$window.one('eAu:content:beforechange', function () {
		$('#eAu-test-interrupt > a, #eAu-test-skip > a').unbind('click');
	});
}

var UAGenerator = {
	compare: function (Q) {
		return UAGenerator.fillingaps.apply(UAGenerator, arguments);
	},
	fill: function (Q) {
		return UAGenerator.fillingaps.apply(UAGenerator, arguments);
	},
	fillingaps: function (Q) {
		var QNode = document.getElementById('eAu-question-' + Q.id);
		
		if (!QNode) { return {}; }
		
		return _(Q.answerNodes).reduce(function (memo, answer) {
			var id = _Xml.id(answer)
			  , safeId = _Xml.safeId(id, 'gap')
			  , nodes = $(QNode).find("input[name='"+ safeId +"'][is-gap='yes'], select[name='"+ safeId +"'][is-gap='yes']");
			if (nodes.length) {
				memo[id] = _(nodes.get()).map(function (item) {
					var $item = $(item)
					  , val = [];
					if ($item.is('input')) {
						val.push(item.value || '');
					} else if ($item.is('select')) {
						val = $item.find(':selected').map(function () {
							return this.getAttribute('val');
						}).get();
					}
					return val;
				});
			}
			return memo;
		}, {});
	},
	single: function (QuestionHash) {
		return _.reduce(QuestionHash['answerNodes'], function (memo, Answer) {
			var AnswerId = _Xml.id(Answer),
			    AnswerNode = document.getElementById('EU-' + QuestionHash['id'] + '-' + AnswerId);
			if (AnswerNode) {
				memo[AnswerId] = AnswerNode.checked;
			}
			return memo;
		}, {});
	},
	multiple: function (QuestionHash) {
		return this.single.apply(this, arguments);
	},
	sort: function (QuestionHash) {
		var SortableNode = document.getElementById('EU-SORT-' + QuestionHash['id']);
		if (!SortableNode) {
			return {};
		}
		return _.reduce($(SortableNode).sortable('toArray'), function (memo, AnswerId, index) {
			memo[AnswerId] = (index + 1);
			return memo;
		}, {});
	},
	classify: function (QuestionHash) {
		var SortableNodes = $('div.eAu-sortable-useranswer.eAu-sortable-' + _Xml.safeId(QuestionHash['id'])).get();
		return _.reduce(SortableNodes, function (memo, Sortable) {
			var $Sortable = $(Sortable),
			    GroupName = $Sortable.attr('group');
			_.each($Sortable.sortable('toArray'), function (AnswerId) {
				memo[AnswerId] = GroupName;
			});
			return memo;
		}, {});
	},
	exercise: function (QuestionHash) {
		var ObjectNode = QuestionHash['answerNodes'][0],
		    flashNode;
		if (!ObjectNode || !question_exercise_get_flash_loaded(_Xml.id(ObjectNode))) {
			return {};
		}
		
		flashNode = document.getElementById(_Xml.safeId(ObjectNode));
		try {
			return {
				'score.raw':        parseFloat(flashNode.callMethod('getValue', 'score.raw'), 10),
				'score.min':        parseFloat(flashNode.callMethod('getValue', 'score.min'), 10),
				'score.max':        parseFloat(flashNode.callMethod('getValue', 'score.max'), 10),
				'errors.raw':       parseInt(flashNode.callMethod('getValue', 'errors.raw'), 10),
				'comletion_status': String(flashNode.callMethod('getValue', 'completion_status'))
			};
		} catch (error) {
			return {};
		}
	}
}

// Некоторым типам вопросов не обойтись без
// специфичных сериализаторов, например classify
// т.к. в lastTry утеряна информация о порядке элементов
// в блоке
var QSerializers = {
	classify: function (QuestionHash) {
		var SortableNodes = $('div.eAu-sortable-useranswer.eAu-sortable-' + _Xml.safeId(QuestionHash['id'])).get();
		return QuestionHash['htmlSerializedForm'] = _.reduce(SortableNodes, function (memo, Sortable) {
			var $Sortable = $(Sortable);
			memo[$Sortable.attr('id')] = $Sortable.sortable('toArray');
			return memo;
		}, {});
	}
}

var QUnserializers = {
	compare: function (QuestionHash) {
		return QUnserializers.fillingaps.apply(QUnserializers, arguments);
	},
	fill: function (Q) {
		return QUnserializers.fillingaps.apply(QUnserializers, arguments);
	},
	fillingaps: function (Q) {
		var LastTry = Q.lastTry
		  , QNode = document.getElementById('eAu-question-' + Q.id)
		  , hash = {};

		if (!LastTry || !QNode) { return; }

		$(QNode).find('input[is-gap="yes"], select[is-gap="yes"]').each(function () {
			var $this = $(this)
			  , dbid = $this.data('dbid');

			hash[dbid] || (hash[dbid] = 0);
			hash[dbid]++;

			if ($this.is('input')) {
				$this.val(LastTry[dbid][ hash[dbid] - 1 ][0]);
			} else if ($this.is('select')) {
				if (LastTry[dbid][ hash[dbid] - 1 ].length) {
					$this.val(LastTry[dbid][ hash[dbid] - 1 ]);
					if ($.fn.multiselect && $this.is(':ech-multiselect'))
						$this.multiselect('refresh');
				} else if (!$.fn.multiselect || !$this.is(':ech-multiselect')) {
					$this.get(0).selectedIndex = 0;
				}
			}
		});
	},
	single: function (QuestionHash) {
		_.each(QuestionHash['lastTry'] || {}, function (Answer, id) {
			var node = document.getElementById( 'EU-' + QuestionHash['id'] + '-' + id );
			if (!node) { return; }
			node.checked = Answer;
		});
	},
	multiple: function (QuestionHash) {
		return this.single.apply(this, arguments);
	},
	sort: function (QuestionHash) {
		var Box = document.getElementById('EU-SORT-' + QuestionHash['id']);
		var SortableOrder = _.sortBy(_.keys( QuestionHash['lastTry'] || {} ), function (AnswerId) {
			return QuestionHash['lastTry'][AnswerId];
		});
		_.each(SortableOrder, function(value) {
			// jQuery странно работает с нашими DB_ID
			$(document.getElementById(value)).appendTo(Box);
		});
	},
	classify: function (QuestionHash) {
		_.each(QuestionHash['htmlSerializedForm'] || {}, function(value, key) {
			var Box = document.getElementById(key);
			for (var i = 0; Box && i < value.length; ++i) {
				$(document.getElementById(value[i])).appendTo(Box);
			}
		});
	},
	exercise: function (QuestionHash) {
		// TODO: API additions
	}
}

function visualiseFeedback (q, aIds, htmlnodes, pos) {
	var feedbacks = q.feedback(q.lastTry);
	aIds = _.uniq(aIds);
	_(aIds).each(function (id) {
		var feedbackText
		  , $node = $('<a href="#" class="eAu-answer-feedback-item"><span>Примечания</span></a>');
		if (feedbacks[id] && feedbacks[id].length) {
			if (_.isArray(feedbacks[id][0])) {
				_(feedbacks[id]).each(function (feedback, i) {
					if (!feedback.length) return;
					var feedbackText = '<h2 class="eAu">Обратная связь</h2><div>' + text_transform('<p>' + feedback.join('</p><p>') + '</p>') + '</div>'
					  , $node = $('<a href="#" class="eAu-answer-feedback-item"><span>Примечания</span></a>');
					$node.click(function (event) {
						event.preventDefault();
						new eAu.Tooltip(feedbackText, {target: $(this)});
					});
					$(_.isArray(htmlnodes[id]) ? htmlnodes[id][i] : htmlnodes[id])[pos || 'append']($node);
				});
			} else {
				feedbackText = '<h2 class="eAu">Обратная связь</h2><div>' + text_transform('<p>' + feedbacks[id].join('</p><p>') + '</p>') + '</div>';
				$node.click(function (event) {
					event.preventDefault();
					new eAu.Tooltip(feedbackText, {target: $(this)});
				});
				$(htmlnodes[id])[pos || 'append']($node);
			}
		}
	})
}

var UAShowRA = {
	compare: function (Q) {
		return UAShowRA.fillingaps.apply(UAShowRA, arguments);
	},
	fill: function (Q) {
		return UAShowRA.fillingaps.apply(UAShowRA, arguments);
	},
	fillingaps: function (Q) {
		var LastTry = Q.lastTry
		  , ScoreDetails = Q.scoreDetails
		  , QNode = document.getElementById('eAu-question-' + Q.id)
		  , feedbackData = {qid: [], html: {}}
		  , hash = {};

		if (!QNode) { return; }

		$(QNode).find('input[is-gap="yes"], select[is-gap="yes"]').each(function () {
			var $this = $(this)
			  , $span = $('<span class="eAu-user-answer"></span>')
			  , dbid = $this.data('dbid')
			  , multiple = (_.isUndefined(Q.options.dd) || Q.options.dd[dbid]) && !_.isUndefined(Q.options.multiple) && Q.options.multiple[dbid]
			  , ua
			  , ra
			  , idx;
			
			hash[dbid] || (hash[dbid] = 0);
			hash[dbid]++;
			
			idx = hash[dbid] - 1;
			
			$.fn.multiselect && $this.is(':ech-multiselect') && $this.multiselect('destroy');
			
			ua = _(LastTry[dbid][idx] || []).map(function (ua) {
				return eAu.String.escape(ua || '') || '<em>пустое значение</em>';
			}).join(' <span class="eAu-fill-or">и</span> ') || '<strong>вы не дали ответа</strong>';
			
			if (ScoreDetails[dbid][idx] === true) {
				$span.addClass('eAu-right-user-answer');
			} else {
				ra = _(ScoreDetails[dbid][idx] || []).map(function (ra) {
					return eAu.String.escape(ra || '') || '<em>пустое значение</em>';
				}).join(' <span class="eAu-fill-or">'+ (multiple ? 'и' : 'или') +'</span> ') || '<strong>любой ответ верен</strong>';
				$span.addClass('eAu-wrong-user-answer');
				$span.css('cursor', 'pointer').click(function (event) {
					event.preventDefault();
					new eAu.Tooltip('<h2 class="eAu">Верный ответ</h2><div class="eAu-question-container">' + ra + '</div>', {target: $(this)});
				});
			}
			$span.html(ua);
			
			$this.before($span).attr('readonly', 'readonly').hide();
			
			feedbackData.qid.push(dbid)
			feedbackData.html[dbid] || (feedbackData.html[dbid] = []);
			feedbackData.html[dbid].push(this);
		});
		visualiseFeedback(Q, feedbackData.qid, feedbackData.html, 'after');
	},
	single: function (QuestionHash) {
		var LastTry = QuestionHash['lastTry']
		  , ScoreDetails = QuestionHash['scoreDetails']
		  , feedbackData = {qid: [], html: []};
		
		eAu.TestUI.unserialize(QuestionHash);
		
		_.each(QuestionHash['answerNodes'], function (Answer, i) {
			var AnswerId = _Xml.id(Answer)
			  , AnswerHTMLNode = document.getElementById('EU-' + QuestionHash['id'] + '-' + AnswerId)
			  , AnswerHTMLRow = $(AnswerHTMLNode).closest('.eAu-question-answer-item')
			  , additionalCondition = true;
			
			if (!AnswerHTMLNode) return;
			
			AnswerHTMLNode.disabled = true;
			if (QuestionHash['scoreByWeights']) {
				AnswerHTMLRow.addClass('eAu-test-answer-noop');
			} else {
				if (LastTry[AnswerId] === true && ScoreDetails[AnswerId] !== true)
					AnswerHTMLRow.addClass('eAu-test-answer-user-failed');
				else if (LastTry[AnswerId] === true && ScoreDetails[AnswerId] === true)
					AnswerHTMLRow.addClass('eAu-test-answer-user-succeeded');
				AnswerHTMLRow.addClass(QuestionHash['rightAnswer'][AnswerId] === true ? 'eAu-right-answer' : 'eAu-wrong-answer');
			}
			feedbackData.qid.push(AnswerId);
			feedbackData.html[AnswerId] = AnswerHTMLRow;
		});
		visualiseFeedback(QuestionHash, feedbackData.qid, feedbackData.html);
	},
	multiple: function (QuestionHash) {
		return this.single.apply(this, arguments);
	},
	sort: function (QuestionHash) {
		var LastTry = QuestionHash['lastTry']
		  , ScoreDetails = QuestionHash['scoreDetails']
		  , feedbackData = {qid: [], html: []};
		
		eAu.TestUI.unserialize(QuestionHash);
		
		_.each(QuestionHash['answerNodes'], function (Answer, i) {
			var AnswerId = _Xml.id(Answer),
			    AnswerHTMLNode = document.getElementById(AnswerId),
			    RightAnswerHTMLNode = document.getElementById('EU-RA-' + AnswerId);
			
			if (!AnswerHTMLNode) return;
			
			if (ScoreDetails[AnswerId] !== true) {
				$(AnswerHTMLNode).addClass('eAu-wrong-user-answer');
				$(RightAnswerHTMLNode).html('<div>'+ (ScoreDetails[AnswerId]) +'</div>');
			} else {
				$(AnswerHTMLNode).addClass('eAu-right-user-answer');
				$(RightAnswerHTMLNode).html('<div>'+ (LastTry[AnswerId]) +'</div>');
			}
			
			feedbackData.qid.push(AnswerId);
			feedbackData.html[AnswerId] = RightAnswerHTMLNode;
		});
		visualiseFeedback(QuestionHash, feedbackData.qid, feedbackData.html, 'prepend');
	},
	classify: function (QuestionHash) {
		var ScoreDetails = QuestionHash['scoreDetails']
		  , feedbackData = {qid: [], html: []};
		
		eAu.TestUI.unserialize(QuestionHash);
		
		_.each(QuestionHash['answerNodes'], function (Answer, i) {
			var AnswerId = _Xml.id(Answer),
			    AnswerHTMLNode = document.getElementById(AnswerId),
			    RightAnswerHTMLNode = document.getElementById('EU-RA-' + AnswerId);
			
			if (!AnswerHTMLNode) return;
			
			if (ScoreDetails[AnswerId] !== true) {
				$(AnswerHTMLNode).addClass('eAu-wrong-user-answer');
				$(RightAnswerHTMLNode).html('<div>'+ (ScoreDetails[AnswerId] || '<i>Категория без имени</i>') +'</div>');
			} else {
				$(AnswerHTMLNode).addClass('eAu-right-user-answer');
			}
			
			feedbackData.qid.push(AnswerId);
			feedbackData.html[AnswerId] = RightAnswerHTMLNode;
		});
		visualiseFeedback(QuestionHash, feedbackData.qid, feedbackData.html, 'prepend');
	},
	exercise: function (QuestionHash) {
		// TODO
	}
}

function showRightAnswer (Test, Question) {
	var comments = Question.comments(Question['lastTry']),
	    result = Math.floor(Question['score'] * 100) / 100,
	    text = '',
	    $summaryContainer,
	    $answersContainer;
	comments = _.map(comments, function (comment) {
		return '<div class="eAu-question-comment">'+ comment +'</div>';
	}).join('\n	');
	comments.length && (comments = text_transform([
		'<div class="eAu-question-comments">',
		'	<div class="eAu-question-comments-title"><h3 class="eAu">Комментарии:</h3></div>',
		'	' + comments,
		'</div>'
	].join('\n')));

	$answersContainer = $(document.getElementById('eAu-question-answers-' + Question['id']))
		.removeClass('eAu-question-answers-interactive');
	$summaryContainer = $(document.getElementById('eAu-question-user-answer-summary-' + Question['id']))
		.html([
			'<div>' + (Question['scoreByWeights'] ? 'Вопрос оценивается по весам, вы' : 'Вы ответили на вопрос,') + ' набрали ' + inflectWord(result, 'балл') +' из '+ inflectWord(Question['scoreMax'], 'возможность') +' и использовали ' + inflectWord(Question['tryesCount'], 'попытка') + '</div>',
			comments
		].join(''));

	_.defer(function () {
		$summaryContainer
			.show('blind', 300)
			.effect('highlight', 600);
	});

	if (_.isFunction(UAShowRA[Question['type']])) {
		UAShowRA[Question['type']](Question);
	}
}

function renderQuestions (CurrentTest) {
	showContentLoader();

	var CurrentQuestions = CurrentTest.queue.get('current')
	  , QTransformGroup = CurrentTest.getTestNode().cloneNode(false)
	  , QDocument = Sarissa.getDomDocument();
	
	_Xml.attr(QTransformGroup, 'eAu-transform-group', 'yes');
	
	_.each(CurrentQuestions, function (Question) {
		QTransformGroup.appendChild(prepareQuestionNode(Question));
	});

	QTransformGroup = QDocument.importNode(head.cloneNode(false), true)
		.appendChild(QTransformGroup);
	QDocument.appendChild(QTransformGroup.parentNode);

	$window.one('eAu:content:afterchange', function (event) {
		_.each(CurrentQuestions, function (Question) {
			prepareQuestionHTML(Question, 'eAu:content:afterchange');
		});

		loadTestNavInfo(CurrentTest, CurrentQuestions);

		_.each(CurrentQuestions, function (Question) {
			Question.timer({
				finish: function () {
					$window.trigger('eAu:test:question:timer:finish', [CurrentTest, Question]);
				},
				callback: function (duration) {
					$(document.getElementById('eAu-question-statistics-' + Question['id'])).show();
					$(document.getElementById('eAu-question-time-' + Question['id'])).html('у вас ' + inflectTimeString(duration, true) + ' для ответа на вопрос');
				}
			});
			
		});
	});
	// IE 6
	$window.one('eAu:content:afterchange:animation-complete', function () {
		_.each(CurrentQuestions, function (Question) {
			prepareQuestionHTML(Question, 'eAu:content:afterchange:animation-complete');
			eAu.TestUI.unserialize(Question, 'after');
		});
	});
	text_transform(transformToText(QTransformGroup, commonXSL), 'cont');
}

function isEventCanceled (event) {
	return event.isPropagationStopped() || event.isImmediatePropagationStopped() || event.result === false;
}

// Очищаем очеред эффектов если обновляется содержимого #cont
$window.bind('eAu:content:beforechange unload', function (event, data) {
	if (data && data.node && !$(data.node).is('#cont')) {
		return;
	}
	// 2-й параметр - jump to end, но ввиду асинхронности анимаций
	// он всего-лишь просит выполнить последний шаг, который случится
	// где-то через 13 милисекунд и выполнит onComplete handler
	$('#cont *:animated').stop(true, false);
	$('.eAu-sortable').sortable('destroy');
});

// Запретить любые действия в тесте, кроме показа статистики
$window.bind('eAu:test:interrupt:request eAu:test:skip:request eAu:test:finish:request eAu:test:page:next:request eAu:test:page:previous:request eAu:test:page:current:request eAu:test:question:answer:request eAu:test:question:skip:request', function (event, Test) {
//	console.log('1: ' + event.type);
	if (Test.isFinished()) {
		event.stopImmediatePropagation();
	}
});

// События для работы с таймерами
$window.bind('eAu:test:question:answer eAu:test:question:skip', function (event, Test, Question) {
//	console.log('2: ' + event.type);
	Question.timer('interrupt');
});
$window.bind('eAu:test:interrupt eAu:test:skip eAu:test:page:previous eAu:test:timer:finish', function (event, Test) {
//	console.log('3: ' + event.type);
	interruptQuestionTimers(Test);
});
$window.bind('eAu:test:interrupt eAu:test:skip eAu:test:all-done', function (event, Test) {
//	console.log('4: ' + event.type);
	Test.timer('interrupt');
});

// Запросы на прерывание теста
$window.bind('eAu:test:interrupt:request', function (event, Test) {
//	console.log('5: ' + event.type);
	if (!Test.isInterruptAllowed()) {
		event.stopPropagation();
		return false;
	}
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:interrupt', [Test]);
		}
	});
});
$window.bind('eAu:test:skip:request', function (event, Test) {
//	console.log('6: ' + event.type);
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:skip', [Test]);
		}
	});
});
$window.bind('eAu:test:all-done:request', function (event, Test) {
//	console.log('7: ' + event.type);
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:all-done', [Test]);
		}
	});
});

// Безусловное завершение теста
// По таймеру
$window.bind('eAu:test:timer:finish', function (event, Test) {
//	console.log('8: ' + event.type);
	_.defer(function () {
		$window.trigger('eAu:test:finish', [Test, TEST_FINISH_STATUS_TIMEOUT]);
		_.each(Test.queue.getQuestionsWithUndefinedStatus() || [], function (Question) {
			$window.trigger('eAu:test:question:answer', [Test, Question]);
		});
	});
});
// По запросу на прерывание
$window.bind('eAu:test:interrupt', function (event, Test) {
//	console.log('9: ' + event.type);
	_.defer(function () {
		$window.trigger('eAu:test:finish', [Test, TEST_FINISH_STATUS_INTERRUPT]);
		_.each(Test.queue.getQuestionsWithUndefinedStatus() || [], function (Question) {
			$window.trigger('eAu:test:question:skip', [Test, Question]);
		});
	});
});
// По запросу на пропуск теста
$window.bind('eAu:test:skip', function (event, Test) {
//	console.log('10: ' + event.type);
	_.defer(function () {
		$window.trigger('eAu:test:finish', [Test, TEST_FINISH_STATUS_SKIP]);
		_.each(Test.queue.getQuestionsWithUndefinedStatus() || [], function (Question) {
			$window.trigger('eAu:test:question:skip', [Test, Question]);
		});
	});
});
// После ответа на все вопросы
$window.bind('eAu:test:all-done', function (event, Test) {
//	console.log('11: ' + event.type);
	_.defer(function () {
		$window.trigger('eAu:test:finish:request', [Test, TEST_FINISH_STATUS_NORMAL]);
	});
});

// Запросы на изменение статуса вопросов
$window.bind('eAu:test:question:answer:request', function (event, Test, Question) {
//	console.log('12: ' + event.type);
	// TODO возможно какие-либо проверки на заполненность формы
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:question:answer', [Test, Question]);
		}
	});
});
$window.bind('eAu:test:question:skip:request', function (event, Test, Question) {
//	console.log('13: ' + event.type);
	if (!Test.queue.isSkipAllowed()) {
		event.stopPropagation();
		return false;
	}
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:question:skip', [Test, Question]);
		}
	});
});
$window.bind('eAu:test:question:show-right-answer:request', function (event, Test, Question) {
//	console.log('14: ' + event.type);
	if (!Test.showRightAnswers() || Test.queue.getStatus(Question) !== 'answer') {
		event.stopPropagation();
		return false;
	}
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:question:show-right-answer', [Test, Question]);
		}
	});
});

// Если у учащегося закончилось время для ответа на вопрос,
// то генерируем событие "Ответить на вопрос"
$window.bind('eAu:test:question:timer:finish', function (event, Test, Question) {
//	console.log('15: ' + event.type);
	_.defer(function () {
		$window.trigger('eAu:test:question:answer', [Test, Question, QUESTION_STATUS_TIMEOUT]);
	});
});
// Засчитать ответ
$window.bind('eAu:test:question:answer', function (event, Test, Question) {
//	console.log('16: ' + event.type);
	Test.queue.answer(Question);
	eAu.TestUI.serialize(Question);
	Question.answer( UAGenerator[ Question['type'] ](Question) );
});
// Пропустить вопрос
$window.bind('eAu:test:question:skip', function (event, Test, Question) {
//	console.log('17: ' + event.type);
	Test.queue.skip(Question);
});
$window.bind('eAu:test:question:show-right-answer', function (event, Test, Question) {
//	console.log('18: ' + event.type);
	$('#content').scrollTop(0);
	showRightAnswer(Test, Question);
});
$window.bind('eAu:test:question:show-right-answer', function (event, Test, Question) {
//	console.log('19: ' + event.type);
	if (!Test.queue.pageStatusSet() || !Test.queue.getQuestionsWithStatus('answer').length || Test.isFinished()) {
		return;
	}
	
	setButton();
	setButton('next-question', function () {
		$window.trigger('eAu:test:page:next:request', [Test]);
	}, Test.queue.isLast() ? 'Окончить тестирование' : 'К следующему вопросу');
	
	if (Test.queue.isPreviousAllowed()) {
		setButton('previous-question', function () {
			$window.trigger('eAu:test:page:current:request', [Test]);
		}, 'Вернуться к текущему вопросу');
	}
});

// Комбинированные события
$window.bind('eAu:test:question:skip eAu:test:question:answer', function (event, Test, Question) {
//	console.log('20: ' + event.type);
	if (!Test.queue.pageStatusSet()) {
		return;
	}
	
	// Нужно, что-бы триггеры выполнились после того, как все хэндлеры текущего события сработали
	// поэтому _.defer()
	if (Test.showRightAnswers() && Test.queue.getQuestionsWithStatus('answer').length) {
		_.defer(function () {
			$window.trigger('eAu:test:page:show-right-answer:request', [Test]);
		});
	} else {
		_.defer(function () {
			$window.trigger('eAu:test:page:next:request', [Test]);
		});
	}
});
// при получении ответа или пропуске вопроса разрушаем sortables и прячем время
$window.bind('eAu:test:question:skip eAu:test:question:answer', function (event, Test, Question) {
//	console.log('21: ' + event.type);
	$('.eAu-sortable-' + _Xml.safeId(Question['id'])).sortable('destroy');
	// Установка кнопок
	$(document.getElementById('eAu-question-time-' + Question['id'])).hide();
	if (!document.getElementById('eAu-question-theme-' + Question['id'])) {
		$(document.getElementById('eAu-question-statistics-' + Question['id'])).hide();
	}
});

// Работа с группами вопросов
$window.bind('eAu:test:page:previous:request', function (event, Test) {
//	console.log('22: ' + event.type);
	if (!Test.queue.isPreviousAllowed() || !Test.queue.get('previous').length) {
		return false;
	}
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:page:previous', [Test]);
		}
	});
});
$window.bind('eAu:test:page:next:request', function (event, Test) {
//	console.log('23: ' + event.type);
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:page:next', [Test]);
		}
	});
});
$window.bind('eAu:test:page:answer:request', function (event, Test) {
//	console.log('24: ' + event.type);
	// TODO возможно какие-либо проверки на заполненность формы
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:page:answer', [Test]);
		}
	});
});
$window.bind('eAu:test:page:skip:request', function (event, Test) {
//	console.log('25: ' + event.type);
	if (!Test.queue.isSkipAllowed()) {
		event.stopPropagation();
		return false;
	}
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:page:skip', [Test]);
		}
	});
});
$window.bind('eAu:test:page:current:request', function (event, Test) {
//	console.log('26: ' + event.type);
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:page:current', [Test]);
		}
	});
});
$window.bind('eAu:test:page:show-right-answer:request', function (event, Test) {
//	console.log('27: ' + event.type);
	if (!Test.showRightAnswers() || !Test.queue.getQuestionsWithStatus('answer').length) {
		event.stopPropagation();
		return false;
	}
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:page:show-right-answer', [Test]);
		}
	});
});

$window.bind('eAu:test:page:previous', function (event, Test) {
//	console.log('28: ' + event.type);
	Test.queue.previous();
	_.defer(function () {
		$window.trigger('eAu:test:page:current:request', [Test]);
	});
});
$window.bind('eAu:test:page:next', function (event, Test) {
//	console.log('29: ' + event.type);
	Test.queue.advance();
	if (!Test.queue.getLeft()) {
		_.defer(function () {
			$window.trigger('eAu:test:all-done:request', [Test]);
		});
	} else {
		_.defer(function () {
			$window.trigger('eAu:test:page:current:request', [Test]);
		});
	}
});
$window.bind('eAu:test:page:answer', function (event, Test) {
//	console.log('30: ' + event.type);
	_.defer(function () {
		_.each(Test.queue.getQuestionsWithUndefinedStatus() || [], function (Question) {
			$window.trigger('eAu:test:question:answer:request', [Test, Question]);
		});
	});
});
$window.bind('eAu:test:page:skip', function (event, Test) {
//	console.log('31: ' + event.type);
	_.defer(function () {
		_.each(Test.queue.getQuestionsWithUndefinedStatus() || [], function (Question) {
			$window.trigger('eAu:test:question:skip:request', [Test, Question]);
		});
	});
});
$window.bind('eAu:test:page:current', function (event, Test) {
//	console.log('32: ' + event.type);
	Test.queue.current();
	renderQuestions(Test);
});
$window.bind('eAu:test:page:current', function (event, Test) {
//	console.log('33: ' + event.type);
	$('#content').scrollTop(0);

	setButton();
	
	setButton('answer-question', function () {
		$window.trigger('eAu:test:page:answer:request', [Test]);
	}, Test.queue.isLast() && !Test.showRightAnswers() ? 'Ответить и завершить тестирование' : 'Ответить');
	
	if (Test.queue.isSkipAllowed() && !Test.queue.isLast()) {
		setButton('next-question', function () {
			$window.trigger('eAu:test:page:skip:request', [Test]);
		}, 'Пропустить неотвеченные вопросы');
	}
	
	if (Test.queue.isPreviousAllowed() && Test.queue.get('previous').length) {
		setButton('previous-question', function () {
			$window.trigger('eAu:test:page:previous:request', [Test]);
		}, 'Вернуться к предыдущему вопросу');
	}
});
$window.bind('eAu:test:page:show-right-answer', function (event, Test) {
//	console.log('34: ' + event.type);
	_.defer(function () {
		_.each(Test.queue.getQuestionsWithStatus('answer'), function (Question) {
			$window.trigger('eAu:test:question:show-right-answer:request', [Test, Question]);
		});
	});
});

$window.bind('eAu:test:finish:request', function (event, Test, status) {
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:finish', [Test, status]);
		}
	});
});
$window.bind('eAu:test:finish', function (event, Test, status) {
//	console.log('35: ' + event.type);
	var result;
	Test.finish(status);
	if (status != TEST_FINISH_STATUS_SKIP) {
		result = Test.score(true);
		if (!DS.has('parentId')) {
			//LMS.setScoredLessonData(result.raw, result.min, result.max);
			//LMS.setLessonStatus(Test.passed() ? 'passed' : 'failed');
		}
	}
});
$window.bind('eAu:test:finish', function (event, Test, status) {
//	console.log('36: ' + event.type);
	$('#eAu-test-skip, #eAu-test-interrupt').hide();
	if (Test.showRightAnswers() && status != TEST_FINISH_STATUS_NORMAL && Test.queue.getQuestionsWithStatus('answer').length && Test.queue.getQuestionsWithUndefinedStatus().length) {
		setButton();
		setButton('next-question', function () {
			$window.trigger('eAu:test:show-finish-summary:request', [Test, status]);
		}, 'Окончить тестирование');
		
		$('#eAu-test-title').text('Тестирование ' + (status == TEST_FINISH_STATUS_SKIP ? 'прервано' : 'завершено'));
	} else {
		_.defer(function () {
			$window.trigger('eAu:test:show-finish-summary:request', [Test, status]);
		});
	}
});

$window.bind('eAu:test:show-finish-summary:request', function (event, Test, status) {
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:show-finish-summary', [Test, status]);
		}
	});
});
$window.bind('eAu:test:show-finish-summary', function (event, Test, status) {
//	console.log('37: ' + event.type);
	var result = Test.score(false);
	setButton();
	$(document).trigger('test:passed');
	loadNavInfo(Test.getTestNode());
	
	var testFinishHeader = '<h1 class="eAu">Тестирование '+ (status != TEST_FINISH_STATUS_SKIP ? 'завершено' : 'прервано') + get_return_link() +'</h1>';
	var testStatString = (Test.getOption('showTestStats') && status != TEST_FINISH_STATUS_SKIP)
		? [
			'<p>Было набрано '+ inflectWord(result.raw, 'балл') +' из '+ inflectWord(result.max, 'возможность') +' ('+ result.percent +'%)</p>',
			'<p>Ответы даны на '+ inflectWord(result.q.answered, 'вопрос') + ' из '+ result.q.total +'</p>'
		  ].join('\n')
		: status != TEST_FINISH_STATUS_SKIP
			? [
				'<p>Оценка была выставлена</p>',
				'<p>Вами набрано '+ result.percent +'%</p>'
			  ].join('\n')
			: '<p>Оценка не была выставлена</p>';
	var testRestartOrContinueString = (sequencingMode == 'linear' && !DS.has('parentId'))
		? (Test.passed()
			? '<p>Вами набрано достаточное количество баллов для продолжения обучения</p>'
			: [
				'<p>Набранного балла недостаточно для продолжения обучения</p>',
				'<p><a href="index.htm" target="_top" class="eAu-test-restart" id="test-restart" onclick="return false;">',
				'	<span>Пройти тест заново</span>',
				'</a></p>'
			  ].join('\n')
		  )
		: '<p>Вы можете продолжить обучение</p>';

	$window.one('eAu:content:afterchange', function () {
		$('#test-restart')
			.one('click', function(event) {
				$window.trigger('eAu:test:start:request', [Test.getTestNode()]);
				return false;
			})
			.click(function () { return false; });
		$window.one('eAu:content:beforechange', function () { $('#test-restart').unbind(); });
	});
	
	text_transform([
			'<div class="eAu-test-statistic">',
				testFinishHeader,
			'	<div class="eAu-test-statistic-text">',
					testStatString,
					'<div class="eAu-test-restart-or-continue">' + testRestartOrContinueString + '</div>',
			'	</div>',
			'</div>'
		].join(''), 'cont');

	if (Test.passed()) {
		//LMS.terminate();
	}
});

function disableFinishSummary (event) {
	event.stopPropagation();
}

function checkForGoToRequests (event, id) {
	if (isEventCanceled(event)) {
		return;
	}

	$window.one('eAu:test:show-finish-summary:request', disableFinishSummary);
	$window.trigger('eAu:test:skip:request', [event.data]);
}

$window.bind('eAu:test:finish', function (event) {
	$window.unbind('eAu:goto:request', checkForGoToRequests);
});

$window.bind('eAu:test:question:answer:request', function (event, Test, Question) {
	if (Question['type'] !== 'exercise') {
		return;
	}

	var ObjectNode = Question['answerNodes'][0],
	    flashNode;
	if (!ObjectNode || !question_exercise_get_flash_loaded(_Xml.id(ObjectNode))) {
		return;
	}

	flashNode = document.getElementById(_Xml.safeId(ObjectNode));
	try {
		if (String(flashNode.callMethod('getValue', 'completion_status')) == 'incomplete') {
			$(document.getElementById('eAu-question-user-answer-summary-' + Question['id']))
				.html('Вы не окончили упражнение')
				.effect('highlight');
			event.stopPropagation();
		}
	} catch (error) {}
});

function showIntro (node) {
	$window.one('eAu:content:afterchange', function () {
		$('#test-restart')
			.one('click', function(event) {
				$window.trigger('eAu:test:start:request', [node]);
				return false;
			})
			.click(function () { return false; });
		$window.one('eAu:content:beforechange', function () { $('#test-restart').unbind(); });
	});
	text_transform([
		'<h1 class="eAu">'+ _Xml.title(node) + get_return_link() +'</h1>',
		'<div class="eAu-test-intro">',
		'	<p>Вы уже прошли тест и набрали '+ inflectWord(eAu.Test.getOption(node, 'scorePercent'), 'процент') +'</p>',
		((sequencingMode == 'linear' && !DS.has('parentId'))
			? '<p>Для получения зачёта по данному тесту вам необходимо набрать '+ inflectWord(eAu.Test.getOption(node, 'passedPC'), 'процент') +'</p>'
			: ''
		),
		'	<p>Хотите заново пройти тестирование?</p>',
		'	<p><a href="index.htm" target="_top" class="eAu-test-restart" id="test-restart" onclick="return false;"><span>Пройти тест</span></a></p>',
		'</div>'
	].join(''), 'cont');
}

$window.bind('eAu:test:initialize:request', function (event, node) {
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:initialize', [node]);
		}
	});
});
$window.bind('eAu:test:start:request', function (event, node) {
	_.defer(function () {
		if (!isEventCanceled(event)) {
			$window.trigger('eAu:test:start', [node]);
		}
	});
});

$window.bind('eAu:test:initialize', function (event, node) {
	if ((Test.attempted(node) && sequencingMode == 'free') ||
	    (Test.passed(node) && sequencingMode == 'linear')) {
		showIntro(node);
	} else {
		_.defer(function () {
			$window.trigger('eAu:test:start:request', [node]);
		});
	}
});
$window.bind('eAu:test:start', function (event, node) {
	var CurrentTest;
	//LMS.setLessonStatus('incomplete');
	
	CurrentTest = eAu.Test.create(node);
	CurrentTest.start();

	if (CurrentTest.queue.isEmpty()) {
		text_transform('<div class="eU-error"><h2 class="eU-error-title">Ошибка загрузки теста</h2><div class="eU-error-text">Не найдено ни одного вопроса</div></div>', 'cont')
		return;
	}

	// TODO: looks bad
	loadNavInfo(CurrentTest.queue.get('current')[0]['xmlNode']);

	CurrentTest.timer({
		finish: function () {
			$window.trigger('eAu:test:timer:finish', [CurrentTest]);
		},
		callback: function (duration) {
			$('#eAu-test-time').html('у вас ' + inflectTimeString(duration, true) + ' до окончания тестирования');
		}
	});

	$window.unbind('eAu:test:show-finish-summary:request', disableFinishSummary);
	$window.bind('eAu:goto:request', CurrentTest, checkForGoToRequests);

	_.defer(function () {
		$window.trigger('eAu:test:page:current:request', [CurrentTest]);
	});
});

eAu.TestUI = {
	unserialize: function (cq) {
		if (!cq) { return; }

		if ( _.isFunction(QUnserializers[ cq['type'] ]) ) {
			QUnserializers[ cq['type'] ](cq);
		}
	},
	serialize: function (cq) {
		if (!cq) { return; }

		if ( _.isFunction(QSerializers[ cq['type'] ]) ) {
			QSerializers[ cq['type'] ](cq);
		}
	},
	load: function (node) {
		$window.trigger('eAu:test:initialize:request', [node]);
	}
}

})();

// HINT: пример как пользоваться request событиями
/*
$window.bind('eAu:test:question:answer:request', function (event, Test, Question) {
	event.stopImmediatePropagation();
	// или
	event.stopPropagation();
});
*/

/* END: вспомогательные функции теста */
